package reparto_intmex.keymon.lat;


import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.B4AClass;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.debug.*;

public class cl_appupdate extends B4AClass.ImplB4AClass implements BA.SubDelegator{
    private static java.util.HashMap<String, java.lang.reflect.Method> htSubs;
    private void innerInitialize(BA _ba) throws Exception {
        if (ba == null) {
            ba = new anywheresoftware.b4a.ShellBA(_ba, this, htSubs, "reparto_intmex.keymon.lat.cl_appupdate");
            if (htSubs == null) {
                ba.loadHtSubs(this.getClass());
                htSubs = ba.htSubs;
            }
            
        }
        if (BA.isShellModeRuntimeCheck(ba)) 
			   this.getClass().getMethod("_class_globals", reparto_intmex.keymon.lat.cl_appupdate.class).invoke(this, new Object[] {null});
        else
            ba.raiseEvent2(null, true, "class_globals", false);
    }

 
    public void  innerInitializeHelper(anywheresoftware.b4a.BA _ba) throws Exception{
        innerInitialize(_ba);
    }
    public Object callSub(String sub, Object sender, Object[] args) throws Exception {
        return BA.SubDelegator.SubNotFound;
    }
public anywheresoftware.b4a.keywords.Common __c = null;
public int _err_nopkg = 0;
public int _err_notxt = 0;
public int _err_noapk = 0;
public int _err_txtrow = 0;
public int _err_html = 0;
public int _err_nospace = 0;
public int _err_noperm = 0;
public int _err_download = 0;
public int _err_http = 0;
public int _ok_init = 0;
public int _ok_curver = 0;
public int _ok_webver = 0;
public int _no_newerapk = 0;
public int _ok_newerapk = 0;
public int _ok_download = 0;
public int _ok_install = 0;
public Object _callback = null;
public String _event = "";
public String _spackagename = "";
public String _snewvertxt = "";
public String _snewverapk = "";
public int _sstatuscode = 0;
public String _susername = "";
public String _supassword = "";
public String _curver = "";
public String _webver = "";
public String _webclog = "";
public String _webfsize = "";
public boolean _sverbose = false;
public anywheresoftware.b4a.objects.PanelWrapper _pnlsplash = null;
public boolean _splashshowing = false;
public anywheresoftware.b4a.phone.Phone _phone = null;
public anywheresoftware.b4a.objects.RuntimePermissions _rp = null;
public String _sharedfolder = "";
public boolean _usefileprovider = false;
public int _logcolor1 = 0;
public b4a.example.dateutils _dateutils = null;
public reparto_intmex.keymon.lat.main _main = null;
public reparto_intmex.keymon.lat.appupdater _appupdater = null;
public reparto_intmex.keymon.lat.foto _foto = null;
public reparto_intmex.keymon.lat.mapa_cliente _mapa_cliente = null;
public reparto_intmex.keymon.lat.mapa_rutas _mapa_rutas = null;
public reparto_intmex.keymon.lat.starter _starter = null;
public reparto_intmex.keymon.lat.subs _subs = null;
public reparto_intmex.keymon.lat.tracker _tracker = null;
public reparto_intmex.keymon.lat.newinst2 _newinst2 = null;
public reparto_intmex.keymon.lat.b4xpages _b4xpages = null;
public reparto_intmex.keymon.lat.b4xcollections _b4xcollections = null;
public reparto_intmex.keymon.lat.httputils2service _httputils2service = null;
public reparto_intmex.keymon.lat.xuiviewsutils _xuiviewsutils = null;
public boolean  _canrequestpackageinstalls(reparto_intmex.keymon.lat.cl_appupdate __ref) throws Exception{
__ref = this;
RDebugUtils.currentModule="cl_appupdate";
if (Debug.shouldDelegate(ba, "canrequestpackageinstalls", true))
	 {return ((Boolean) Debug.delegate(ba, "canrequestpackageinstalls", null));}
anywheresoftware.b4j.object.JavaObject _ctxt = null;
anywheresoftware.b4j.object.JavaObject _packagemanager = null;
RDebugUtils.currentLine=2228224;
 //BA.debugLineNum = 2228224;BA.debugLine="Public Sub CanRequestPackageInstalls As Boolean";
RDebugUtils.currentLine=2228225;
 //BA.debugLineNum = 2228225;BA.debugLine="Dim ctxt As JavaObject";
_ctxt = new anywheresoftware.b4j.object.JavaObject();
RDebugUtils.currentLine=2228226;
 //BA.debugLineNum = 2228226;BA.debugLine="ctxt.InitializeContext";
_ctxt.InitializeContext(ba);
RDebugUtils.currentLine=2228227;
 //BA.debugLineNum = 2228227;BA.debugLine="Dim PackageManager As JavaObject = ctxt.RunMethod";
_packagemanager = new anywheresoftware.b4j.object.JavaObject();
_packagemanager = (anywheresoftware.b4j.object.JavaObject) anywheresoftware.b4a.AbsObjectWrapper.ConvertToWrapper(new anywheresoftware.b4j.object.JavaObject(), (java.lang.Object)(_ctxt.RunMethod("getPackageManager",(Object[])(__c.Null))));
RDebugUtils.currentLine=2228228;
 //BA.debugLineNum = 2228228;BA.debugLine="Return PackageManager.RunMethod(\"canRequestPackag";
if (true) return BA.ObjectToBoolean(_packagemanager.RunMethod("canRequestPackageInstalls",(Object[])(__c.Null)));
RDebugUtils.currentLine=2228229;
 //BA.debugLineNum = 2228229;BA.debugLine="End Sub";
return false;
}
public boolean  _checknonmarketappsenabled(reparto_intmex.keymon.lat.cl_appupdate __ref) throws Exception{
__ref = this;
RDebugUtils.currentModule="cl_appupdate";
if (Debug.shouldDelegate(ba, "checknonmarketappsenabled", true))
	 {return ((Boolean) Debug.delegate(ba, "checknonmarketappsenabled", null));}
anywheresoftware.b4j.object.JavaObject _context = null;
anywheresoftware.b4j.object.JavaObject _resolver = null;
anywheresoftware.b4j.object.JavaObject _global = null;
RDebugUtils.currentLine=2293760;
 //BA.debugLineNum = 2293760;BA.debugLine="Public Sub CheckNonMarketAppsEnabled As Boolean";
RDebugUtils.currentLine=2293761;
 //BA.debugLineNum = 2293761;BA.debugLine="If phone.SdkVersion >= 26 Then Return True";
if (__ref._phone /*anywheresoftware.b4a.phone.Phone*/ .getSdkVersion()>=26) { 
if (true) return __c.True;};
RDebugUtils.currentLine=2293762;
 //BA.debugLineNum = 2293762;BA.debugLine="If phone.SdkVersion < 17 Or phone.SdkVersion >= 2";
if (__ref._phone /*anywheresoftware.b4a.phone.Phone*/ .getSdkVersion()<17 || __ref._phone /*anywheresoftware.b4a.phone.Phone*/ .getSdkVersion()>=21) { 
RDebugUtils.currentLine=2293763;
 //BA.debugLineNum = 2293763;BA.debugLine="Return phone.GetSettings(\"install_non_market_app";
if (true) return (__ref._phone /*anywheresoftware.b4a.phone.Phone*/ .GetSettings("install_non_market_apps")).equals("1");
 }else {
RDebugUtils.currentLine=2293765;
 //BA.debugLineNum = 2293765;BA.debugLine="Dim context As JavaObject";
_context = new anywheresoftware.b4j.object.JavaObject();
RDebugUtils.currentLine=2293766;
 //BA.debugLineNum = 2293766;BA.debugLine="context.InitializeContext";
_context.InitializeContext(ba);
RDebugUtils.currentLine=2293767;
 //BA.debugLineNum = 2293767;BA.debugLine="Dim resolver As JavaObject = context.RunMethod(\"";
_resolver = new anywheresoftware.b4j.object.JavaObject();
_resolver = (anywheresoftware.b4j.object.JavaObject) anywheresoftware.b4a.AbsObjectWrapper.ConvertToWrapper(new anywheresoftware.b4j.object.JavaObject(), (java.lang.Object)(_context.RunMethod("getContentResolver",(Object[])(__c.Null))));
RDebugUtils.currentLine=2293768;
 //BA.debugLineNum = 2293768;BA.debugLine="Dim global As JavaObject";
_global = new anywheresoftware.b4j.object.JavaObject();
RDebugUtils.currentLine=2293769;
 //BA.debugLineNum = 2293769;BA.debugLine="global.InitializeStatic(\"android.provider.Settin";
_global.InitializeStatic("android.provider.Settings.Global");
RDebugUtils.currentLine=2293770;
 //BA.debugLineNum = 2293770;BA.debugLine="Return global.RunMethod(\"getString\", Array(resol";
if (true) return (_global.RunMethod("getString",new Object[]{(Object)(_resolver.getObject()),(Object)("install_non_market_apps")})).equals((Object)("1"));
 };
RDebugUtils.currentLine=2293772;
 //BA.debugLineNum = 2293772;BA.debugLine="End Sub";
return false;
}
public String  _class_globals(reparto_intmex.keymon.lat.cl_appupdate __ref) throws Exception{
__ref = this;
RDebugUtils.currentModule="cl_appupdate";
RDebugUtils.currentLine=327680;
 //BA.debugLineNum = 327680;BA.debugLine="Private Sub Class_Globals";
RDebugUtils.currentLine=327682;
 //BA.debugLineNum = 327682;BA.debugLine="Public ERR_NOPKG = -1	As Int				'missing package";
_err_nopkg = (int) (-1);
RDebugUtils.currentLine=327683;
 //BA.debugLineNum = 327683;BA.debugLine="Public ERR_NOTXT = -2 As Int				'missing webserve";
_err_notxt = (int) (-2);
RDebugUtils.currentLine=327684;
 //BA.debugLineNum = 327684;BA.debugLine="Public ERR_NOAPK = -3 As Int				'missing webserve";
_err_noapk = (int) (-3);
RDebugUtils.currentLine=327685;
 //BA.debugLineNum = 327685;BA.debugLine="Public ERR_TXTROW = -4 As Int				'wrong row forma";
_err_txtrow = (int) (-4);
RDebugUtils.currentLine=327686;
 //BA.debugLineNum = 327686;BA.debugLine="Public ERR_HTML = -5 As Int					'website returned";
_err_html = (int) (-5);
RDebugUtils.currentLine=327687;
 //BA.debugLineNum = 327687;BA.debugLine="Public ERR_NOSPACE = -6 As Int				'no enough spac";
_err_nospace = (int) (-6);
RDebugUtils.currentLine=327688;
 //BA.debugLineNum = 327688;BA.debugLine="Public ERR_NOPERM = -7 As Int				'no permissions";
_err_noperm = (int) (-7);
RDebugUtils.currentLine=327689;
 //BA.debugLineNum = 327689;BA.debugLine="Public ERR_DOWNLOAD = -8 As Int				'failed to dow";
_err_download = (int) (-8);
RDebugUtils.currentLine=327690;
 //BA.debugLineNum = 327690;BA.debugLine="Public ERR_HTTP = -100 As Int				'HttpUtils error";
_err_http = (int) (-100);
RDebugUtils.currentLine=327691;
 //BA.debugLineNum = 327691;BA.debugLine="Public OK_INIT = 0 As Int";
_ok_init = (int) (0);
RDebugUtils.currentLine=327692;
 //BA.debugLineNum = 327692;BA.debugLine="Public OK_CURVER = 1 As Int					'curver has valid";
_ok_curver = (int) (1);
RDebugUtils.currentLine=327693;
 //BA.debugLineNum = 327693;BA.debugLine="Public OK_WEBVER = 2 As Int";
_ok_webver = (int) (2);
RDebugUtils.currentLine=327694;
 //BA.debugLineNum = 327694;BA.debugLine="Public NO_NEWERAPK = 3 As Int				'apk version on";
_no_newerapk = (int) (3);
RDebugUtils.currentLine=327695;
 //BA.debugLineNum = 327695;BA.debugLine="Public OK_NEWERAPK = 4 As Int				'current apk has";
_ok_newerapk = (int) (4);
RDebugUtils.currentLine=327696;
 //BA.debugLineNum = 327696;BA.debugLine="Public OK_DOWNLOAD = 5 As Int				'newer apk corre";
_ok_download = (int) (5);
RDebugUtils.currentLine=327697;
 //BA.debugLineNum = 327697;BA.debugLine="Public OK_INSTALL = 6 As Int				'user asked to in";
_ok_install = (int) (6);
RDebugUtils.currentLine=327700;
 //BA.debugLineNum = 327700;BA.debugLine="Private Callback As Object";
_callback = new Object();
RDebugUtils.currentLine=327701;
 //BA.debugLineNum = 327701;BA.debugLine="Private Event As String";
_event = "";
RDebugUtils.currentLine=327702;
 //BA.debugLineNum = 327702;BA.debugLine="Private sPackageName As String      		'ex: com.te";
_spackagename = "";
RDebugUtils.currentLine=327703;
 //BA.debugLineNum = 327703;BA.debugLine="Private sNewVerTxt As String        		'ex: http:/";
_snewvertxt = "";
RDebugUtils.currentLine=327704;
 //BA.debugLineNum = 327704;BA.debugLine="Private sNewVerApk  As String       		'ex: http:/";
_snewverapk = "";
RDebugUtils.currentLine=327705;
 //BA.debugLineNum = 327705;BA.debugLine="Private sStatusCode As Int          		'negatives";
_sstatuscode = 0;
RDebugUtils.currentLine=327706;
 //BA.debugLineNum = 327706;BA.debugLine="Private sUserName As String         		'user name";
_susername = "";
RDebugUtils.currentLine=327707;
 //BA.debugLineNum = 327707;BA.debugLine="Private sUPassword As String        		'password r";
_supassword = "";
RDebugUtils.currentLine=327708;
 //BA.debugLineNum = 327708;BA.debugLine="Private curver, webver As String    		'curver = c";
_curver = "";
_webver = "";
RDebugUtils.currentLine=327709;
 //BA.debugLineNum = 327709;BA.debugLine="Private webclog As String					'webclog = optional";
_webclog = "";
RDebugUtils.currentLine=327710;
 //BA.debugLineNum = 327710;BA.debugLine="Private webfsize As String					'webfsize = option";
_webfsize = "";
RDebugUtils.currentLine=327711;
 //BA.debugLineNum = 327711;BA.debugLine="Private sVerbose As Boolean					'TRUE = a lot of";
_sverbose = false;
RDebugUtils.currentLine=327712;
 //BA.debugLineNum = 327712;BA.debugLine="Private pnlSplash As Panel					'panel used to sup";
_pnlsplash = new anywheresoftware.b4a.objects.PanelWrapper();
RDebugUtils.currentLine=327713;
 //BA.debugLineNum = 327713;BA.debugLine="Private SplashShowing As Boolean			'True = splash";
_splashshowing = false;
RDebugUtils.currentLine=327714;
 //BA.debugLineNum = 327714;BA.debugLine="Private phone As Phone";
_phone = new anywheresoftware.b4a.phone.Phone();
RDebugUtils.currentLine=327715;
 //BA.debugLineNum = 327715;BA.debugLine="Private rp As RuntimePermissions";
_rp = new anywheresoftware.b4a.objects.RuntimePermissions();
RDebugUtils.currentLine=327716;
 //BA.debugLineNum = 327716;BA.debugLine="Private SharedFolder As String				'Foder where to";
_sharedfolder = "";
RDebugUtils.currentLine=327717;
 //BA.debugLineNum = 327717;BA.debugLine="Private UseFileProvider As Boolean			'TRUE = SDK";
_usefileprovider = false;
RDebugUtils.currentLine=327718;
 //BA.debugLineNum = 327718;BA.debugLine="Private LogColor1 As Int = 0xFFFF8C00		'first col";
_logcolor1 = ((int)0xffff8c00);
RDebugUtils.currentLine=327719;
 //BA.debugLineNum = 327719;BA.debugLine="End Sub";
return "";
}
public void  _downloadapk(reparto_intmex.keymon.lat.cl_appupdate __ref) throws Exception{
RDebugUtils.currentModule="cl_appupdate";
if (Debug.shouldDelegate(ba, "downloadapk", true))
	 {Debug.delegate(ba, "downloadapk", null); return;}
ResumableSub_DownloadApk rsub = new ResumableSub_DownloadApk(this,__ref);
rsub.resume(ba, null);
}
public static class ResumableSub_DownloadApk extends BA.ResumableSub {
public ResumableSub_DownloadApk(reparto_intmex.keymon.lat.cl_appupdate parent,reparto_intmex.keymon.lat.cl_appupdate __ref) {
this.parent = parent;
this.__ref = __ref;
this.__ref = parent;
}
reparto_intmex.keymon.lat.cl_appupdate __ref;
reparto_intmex.keymon.lat.cl_appupdate parent;
reparto_intmex.keymon.lat.httpjob _j = null;
anywheresoftware.b4a.objects.streams.File.OutputStreamWrapper _out = null;

@Override
public void resume(BA ba, Object[] result) throws Exception{
RDebugUtils.currentModule="cl_appupdate";

    while (true) {
        switch (state) {
            case -1:
return;

case 0:
//C
this.state = 1;
RDebugUtils.currentLine=1376257;
 //BA.debugLineNum = 1376257;BA.debugLine="LogColor(\"---- AppUpdating.DownloadApk\", LogColor";
parent.__c.LogImpl("91376257","---- AppUpdating.DownloadApk",__ref._logcolor1 /*int*/ );
RDebugUtils.currentLine=1376259;
 //BA.debugLineNum = 1376259;BA.debugLine="If sNewVerApk = \"\" Then";
if (true) break;

case 1:
//if
this.state = 10;
if ((__ref._snewverapk /*String*/ ).equals("")) { 
this.state = 3;
}if (true) break;

case 3:
//C
this.state = 4;
RDebugUtils.currentLine=1376260;
 //BA.debugLineNum = 1376260;BA.debugLine="sStatusCode = ERR_NOAPK";
__ref._sstatuscode /*int*/  = __ref._err_noapk /*int*/ ;
RDebugUtils.currentLine=1376261;
 //BA.debugLineNum = 1376261;BA.debugLine="If sVerbose Then Log($\"${TAB}missing apk file fu";
if (true) break;

case 4:
//if
this.state = 9;
if (__ref._sverbose /*boolean*/ ) { 
this.state = 6;
;}if (true) break;

case 6:
//C
this.state = 9;
parent.__c.LogImpl("91376261",(""+parent.__c.SmartStringFormatter("",(Object)(parent.__c.TAB))+"missing apk file full path indication"),0);
if (true) break;

case 9:
//C
this.state = 10;
;
RDebugUtils.currentLine=1376262;
 //BA.debugLineNum = 1376262;BA.debugLine="Finito";
__ref._finito /*String*/ (null);
RDebugUtils.currentLine=1376263;
 //BA.debugLineNum = 1376263;BA.debugLine="Return";
if (true) return ;
 if (true) break;

case 10:
//C
this.state = 11;
;
RDebugUtils.currentLine=1376266;
 //BA.debugLineNum = 1376266;BA.debugLine="Dim j As HttpJob";
_j = new reparto_intmex.keymon.lat.httpjob();
RDebugUtils.currentLine=1376267;
 //BA.debugLineNum = 1376267;BA.debugLine="j.Initialize(\"\", Me)";
_j._initialize /*String*/ (null,ba,"",parent);
RDebugUtils.currentLine=1376268;
 //BA.debugLineNum = 1376268;BA.debugLine="j.Username = sUserName";
_j._username /*String*/  = __ref._susername /*String*/ ;
RDebugUtils.currentLine=1376269;
 //BA.debugLineNum = 1376269;BA.debugLine="j.Password = sUPassword";
_j._password /*String*/  = __ref._supassword /*String*/ ;
RDebugUtils.currentLine=1376270;
 //BA.debugLineNum = 1376270;BA.debugLine="j.Download(sNewVerApk)							'ex: j.Download(\"htt";
_j._download /*String*/ (null,__ref._snewverapk /*String*/ );
RDebugUtils.currentLine=1376271;
 //BA.debugLineNum = 1376271;BA.debugLine="Wait For (j) JobDone(j As HttpJob)";
parent.__c.WaitFor("jobdone", ba, new anywheresoftware.b4a.shell.DebugResumableSub.DelegatableResumableSub(this, "cl_appupdate", "downloadapk"), (Object)(_j));
this.state = 29;
return;
case 29:
//C
this.state = 11;
_j = (reparto_intmex.keymon.lat.httpjob) result[1];
;
RDebugUtils.currentLine=1376272;
 //BA.debugLineNum = 1376272;BA.debugLine="Log($\"Donload ok? ${j.Success}\"$)";
parent.__c.LogImpl("91376272",("Donload ok? "+parent.__c.SmartStringFormatter("",(Object)(_j._success /*boolean*/ ))+""),0);
RDebugUtils.currentLine=1376273;
 //BA.debugLineNum = 1376273;BA.debugLine="If j.Success Then";
if (true) break;

case 11:
//if
this.state = 28;
if (_j._success /*boolean*/ ) { 
this.state = 13;
}else {
this.state = 21;
}if (true) break;

case 13:
//C
this.state = 14;
RDebugUtils.currentLine=1376275;
 //BA.debugLineNum = 1376275;BA.debugLine="Dim out As OutputStream";
_out = new anywheresoftware.b4a.objects.streams.File.OutputStreamWrapper();
RDebugUtils.currentLine=1376276;
 //BA.debugLineNum = 1376276;BA.debugLine="out = File.OpenOutput(SharedFolder,\"tmp.apk\",Fal";
_out = parent.__c.File.OpenOutput(__ref._sharedfolder /*String*/ ,"tmp.apk",parent.__c.False);
RDebugUtils.currentLine=1376277;
 //BA.debugLineNum = 1376277;BA.debugLine="File.Copy2(J.GetInputStream, out)";
parent.__c.File.Copy2((java.io.InputStream)(_j._getinputstream /*anywheresoftware.b4a.objects.streams.File.InputStreamWrapper*/ (null).getObject()),(java.io.OutputStream)(_out.getObject()));
RDebugUtils.currentLine=1376278;
 //BA.debugLineNum = 1376278;BA.debugLine="out.Close";
_out.Close();
RDebugUtils.currentLine=1376279;
 //BA.debugLineNum = 1376279;BA.debugLine="Log($\"Copy2 (saving) ok? TRUE\"$)";
parent.__c.LogImpl("91376279",("Copy2 (saving) ok? TRUE"),0);
RDebugUtils.currentLine=1376280;
 //BA.debugLineNum = 1376280;BA.debugLine="sStatusCode = OK_DOWNLOAD";
__ref._sstatuscode /*int*/  = __ref._ok_download /*int*/ ;
RDebugUtils.currentLine=1376281;
 //BA.debugLineNum = 1376281;BA.debugLine="If sVerbose Then Log($\"${TAB}new apk version dow";
if (true) break;

case 14:
//if
this.state = 19;
if (__ref._sverbose /*boolean*/ ) { 
this.state = 16;
;}if (true) break;

case 16:
//C
this.state = 19;
parent.__c.LogImpl("91376281",(""+parent.__c.SmartStringFormatter("",(Object)(parent.__c.TAB))+"new apk version downloaded and ready to install"),0);
if (true) break;

case 19:
//C
this.state = 28;
;
 if (true) break;

case 21:
//C
this.state = 22;
RDebugUtils.currentLine=1376283;
 //BA.debugLineNum = 1376283;BA.debugLine="Log($\"${TAB}Error: ${J.ErrorMessage}\"$)";
parent.__c.LogImpl("91376283",(""+parent.__c.SmartStringFormatter("",(Object)(parent.__c.TAB))+"Error: "+parent.__c.SmartStringFormatter("",(Object)(_j._errormessage /*String*/ ))+""),0);
RDebugUtils.currentLine=1376284;
 //BA.debugLineNum = 1376284;BA.debugLine="sStatusCode = ERR_HTTP";
__ref._sstatuscode /*int*/  = __ref._err_http /*int*/ ;
RDebugUtils.currentLine=1376285;
 //BA.debugLineNum = 1376285;BA.debugLine="If sVerbose Then Log($\"${TAB}error in httputils2";
if (true) break;

case 22:
//if
this.state = 27;
if (__ref._sverbose /*boolean*/ ) { 
this.state = 24;
;}if (true) break;

case 24:
//C
this.state = 27;
parent.__c.LogImpl("91376285",(""+parent.__c.SmartStringFormatter("",(Object)(parent.__c.TAB))+"error in httputils2"),0);
if (true) break;

case 27:
//C
this.state = 28;
;
RDebugUtils.currentLine=1376286;
 //BA.debugLineNum = 1376286;BA.debugLine="ToastMessageShow(\"Error: \" & J.ErrorMessage, Tru";
parent.__c.ToastMessageShow(BA.ObjectToCharSequence("Error: "+_j._errormessage /*String*/ ),parent.__c.True);
 if (true) break;

case 28:
//C
this.state = -1;
;
RDebugUtils.currentLine=1376288;
 //BA.debugLineNum = 1376288;BA.debugLine="j.Release";
_j._release /*String*/ (null);
RDebugUtils.currentLine=1376289;
 //BA.debugLineNum = 1376289;BA.debugLine="Finito";
__ref._finito /*String*/ (null);
RDebugUtils.currentLine=1376290;
 //BA.debugLineNum = 1376290;BA.debugLine="End Sub";
if (true) break;

            }
        }
    }
}
public String  _finito(reparto_intmex.keymon.lat.cl_appupdate __ref) throws Exception{
__ref = this;
RDebugUtils.currentModule="cl_appupdate";
if (Debug.shouldDelegate(ba, "finito", true))
	 {return ((String) Debug.delegate(ba, "finito", null));}
RDebugUtils.currentLine=1638400;
 //BA.debugLineNum = 1638400;BA.debugLine="Private Sub Finito";
RDebugUtils.currentLine=1638401;
 //BA.debugLineNum = 1638401;BA.debugLine="If SubExists(Callback,Event&\"_UpdateComplete\") Th";
if (__c.SubExists(ba,__ref._callback /*Object*/ ,__ref._event /*String*/ +"_UpdateComplete")) { 
RDebugUtils.currentLine=1638402;
 //BA.debugLineNum = 1638402;BA.debugLine="CallSub(Callback,Event&\"_UpdateComplete\")";
__c.CallSubNew(ba,__ref._callback /*Object*/ ,__ref._event /*String*/ +"_UpdateComplete");
 };
RDebugUtils.currentLine=1638404;
 //BA.debugLineNum = 1638404;BA.debugLine="End Sub";
return "";
}
public String  _extractcl(reparto_intmex.keymon.lat.cl_appupdate __ref,String _txtrow) throws Exception{
__ref = this;
RDebugUtils.currentModule="cl_appupdate";
if (Debug.shouldDelegate(ba, "extractcl", true))
	 {return ((String) Debug.delegate(ba, "extractcl", new Object[] {_txtrow}));}
int _i = 0;
int _j1 = 0;
int _j2 = 0;
RDebugUtils.currentLine=1900544;
 //BA.debugLineNum = 1900544;BA.debugLine="Private Sub ExtractCL(TxtRow As String) As String";
RDebugUtils.currentLine=1900545;
 //BA.debugLineNum = 1900545;BA.debugLine="Dim i As Int";
_i = 0;
RDebugUtils.currentLine=1900546;
 //BA.debugLineNum = 1900546;BA.debugLine="i = TxtRow.IndexOf(\"<ChangeLog>\")";
_i = _txtrow.indexOf("<ChangeLog>");
RDebugUtils.currentLine=1900547;
 //BA.debugLineNum = 1900547;BA.debugLine="If i <> -1 Then";
if (_i!=-1) { 
RDebugUtils.currentLine=1900548;
 //BA.debugLineNum = 1900548;BA.debugLine="Dim j1 As Int = TxtRow.IndexOf(\"</ChangeLog>\")";
_j1 = _txtrow.indexOf("</ChangeLog>");
RDebugUtils.currentLine=1900549;
 //BA.debugLineNum = 1900549;BA.debugLine="If j1 = -1 Then";
if (_j1==-1) { 
RDebugUtils.currentLine=1900550;
 //BA.debugLineNum = 1900550;BA.debugLine="Dim j2 As Int = TxtRow.IndexOf(\"<FileSize>\")	'l";
_j2 = _txtrow.indexOf("<FileSize>");
RDebugUtils.currentLine=1900551;
 //BA.debugLineNum = 1900551;BA.debugLine="j1 = j2";
_j1 = _j2;
RDebugUtils.currentLine=1900552;
 //BA.debugLineNum = 1900552;BA.debugLine="If j1 < i Then j1 = -1";
if (_j1<_i) { 
_j1 = (int) (-1);};
 };
RDebugUtils.currentLine=1900554;
 //BA.debugLineNum = 1900554;BA.debugLine="If j1 <> -1 Then Return TxtRow.SubString2(i+11,j";
if (_j1!=-1) { 
if (true) return _txtrow.substring((int) (_i+11),_j1);}
else {
if (true) return _txtrow.substring((int) (_i+11));};
 }else {
RDebugUtils.currentLine=1900556;
 //BA.debugLineNum = 1900556;BA.debugLine="Return \"\"";
if (true) return "";
 };
RDebugUtils.currentLine=1900558;
 //BA.debugLineNum = 1900558;BA.debugLine="End Sub";
return "";
}
public String  _extractsz(reparto_intmex.keymon.lat.cl_appupdate __ref,String _txtrow) throws Exception{
__ref = this;
RDebugUtils.currentModule="cl_appupdate";
if (Debug.shouldDelegate(ba, "extractsz", true))
	 {return ((String) Debug.delegate(ba, "extractsz", new Object[] {_txtrow}));}
int _i = 0;
int _j1 = 0;
int _j2 = 0;
String _s = "";
RDebugUtils.currentLine=1966080;
 //BA.debugLineNum = 1966080;BA.debugLine="Private Sub ExtractSZ(TxtRow As String) As String";
RDebugUtils.currentLine=1966081;
 //BA.debugLineNum = 1966081;BA.debugLine="Dim i As Int";
_i = 0;
RDebugUtils.currentLine=1966082;
 //BA.debugLineNum = 1966082;BA.debugLine="i = TxtRow.IndexOf(\"<FileSize>\")";
_i = _txtrow.indexOf("<FileSize>");
RDebugUtils.currentLine=1966083;
 //BA.debugLineNum = 1966083;BA.debugLine="If i <> -1 Then";
if (_i!=-1) { 
RDebugUtils.currentLine=1966084;
 //BA.debugLineNum = 1966084;BA.debugLine="Dim j1 As Int = TxtRow.IndexOf(\"</FileSize>\")		'";
_j1 = _txtrow.indexOf("</FileSize>");
RDebugUtils.currentLine=1966085;
 //BA.debugLineNum = 1966085;BA.debugLine="If j1 = -1 Then";
if (_j1==-1) { 
RDebugUtils.currentLine=1966086;
 //BA.debugLineNum = 1966086;BA.debugLine="Dim j2 As Int = TxtRow.IndexOf(\"<ChangeLog>\")	'";
_j2 = _txtrow.indexOf("<ChangeLog>");
RDebugUtils.currentLine=1966087;
 //BA.debugLineNum = 1966087;BA.debugLine="j1 = j2";
_j1 = _j2;
RDebugUtils.currentLine=1966088;
 //BA.debugLineNum = 1966088;BA.debugLine="If j1 < i Then j1 = -1";
if (_j1<_i) { 
_j1 = (int) (-1);};
 };
RDebugUtils.currentLine=1966090;
 //BA.debugLineNum = 1966090;BA.debugLine="Dim s As String";
_s = "";
RDebugUtils.currentLine=1966091;
 //BA.debugLineNum = 1966091;BA.debugLine="If j1 <> -1 Then s = TxtRow.SubString2(i+10,j1)";
if (_j1!=-1) { 
_s = _txtrow.substring((int) (_i+10),_j1);}
else {
_s = _txtrow.substring((int) (_i+10));};
RDebugUtils.currentLine=1966092;
 //BA.debugLineNum = 1966092;BA.debugLine="s = s.Replace(CRLF,\"\")";
_s = _s.replace(__c.CRLF,"");
RDebugUtils.currentLine=1966093;
 //BA.debugLineNum = 1966093;BA.debugLine="s=s.Replace(Chr(13),\"\")";
_s = _s.replace(BA.ObjectToString(__c.Chr((int) (13))),"");
RDebugUtils.currentLine=1966094;
 //BA.debugLineNum = 1966094;BA.debugLine="Return s";
if (true) return _s;
 }else {
RDebugUtils.currentLine=1966096;
 //BA.debugLineNum = 1966096;BA.debugLine="Return \"\"";
if (true) return "";
 };
RDebugUtils.currentLine=1966098;
 //BA.debugLineNum = 1966098;BA.debugLine="End Sub";
return "";
}
public String  _extractvn(reparto_intmex.keymon.lat.cl_appupdate __ref,String _txtrow) throws Exception{
__ref = this;
RDebugUtils.currentModule="cl_appupdate";
if (Debug.shouldDelegate(ba, "extractvn", true))
	 {return ((String) Debug.delegate(ba, "extractvn", new Object[] {_txtrow}));}
int _i = 0;
int _j1 = 0;
int _j2 = 0;
int _j = 0;
String _s = "";
RDebugUtils.currentLine=1835008;
 //BA.debugLineNum = 1835008;BA.debugLine="Private Sub ExtractVN(TxtRow As String) As String";
RDebugUtils.currentLine=1835009;
 //BA.debugLineNum = 1835009;BA.debugLine="Dim i As Int";
_i = 0;
RDebugUtils.currentLine=1835010;
 //BA.debugLineNum = 1835010;BA.debugLine="i = TxtRow.IndexOf(\"=\")";
_i = _txtrow.indexOf("=");
RDebugUtils.currentLine=1835011;
 //BA.debugLineNum = 1835011;BA.debugLine="If i <> -1 Then";
if (_i!=-1) { 
RDebugUtils.currentLine=1835012;
 //BA.debugLineNum = 1835012;BA.debugLine="Dim j1 As Int = TxtRow.IndexOf(\"<ChangeLog>\")	'l";
_j1 = _txtrow.indexOf("<ChangeLog>");
RDebugUtils.currentLine=1835013;
 //BA.debugLineNum = 1835013;BA.debugLine="Dim j2 As Int = TxtRow.IndexOf(\"<FileSize>\")	'lo";
_j2 = _txtrow.indexOf("<FileSize>");
RDebugUtils.currentLine=1835014;
 //BA.debugLineNum = 1835014;BA.debugLine="Dim j As Int = Min(j1, j2)";
_j = (int) (__c.Min(_j1,_j2));
RDebugUtils.currentLine=1835015;
 //BA.debugLineNum = 1835015;BA.debugLine="If j = -1 Then j = Max(j1,j2)";
if (_j==-1) { 
_j = (int) (__c.Max(_j1,_j2));};
RDebugUtils.currentLine=1835016;
 //BA.debugLineNum = 1835016;BA.debugLine="Dim s As String";
_s = "";
RDebugUtils.currentLine=1835017;
 //BA.debugLineNum = 1835017;BA.debugLine="If j <> - 1 Then s=TxtRow.SubString2(i+1,j) Else";
if (_j!=-1) { 
_s = _txtrow.substring((int) (_i+1),_j);}
else {
_s = _txtrow.substring((int) (_i+1));};
RDebugUtils.currentLine=1835018;
 //BA.debugLineNum = 1835018;BA.debugLine="s=s.Replace(CRLF,\"\")";
_s = _s.replace(__c.CRLF,"");
RDebugUtils.currentLine=1835019;
 //BA.debugLineNum = 1835019;BA.debugLine="s=s.Replace(Chr(13),\"\")";
_s = _s.replace(BA.ObjectToString(__c.Chr((int) (13))),"");
RDebugUtils.currentLine=1835020;
 //BA.debugLineNum = 1835020;BA.debugLine="Return s";
if (true) return _s;
 }else {
RDebugUtils.currentLine=1835022;
 //BA.debugLineNum = 1835022;BA.debugLine="Return \"\"";
if (true) return "";
 };
RDebugUtils.currentLine=1835024;
 //BA.debugLineNum = 1835024;BA.debugLine="End Sub";
return "";
}
public long  _getavailablespace(reparto_intmex.keymon.lat.cl_appupdate __ref) throws Exception{
__ref = this;
RDebugUtils.currentModule="cl_appupdate";
if (Debug.shouldDelegate(ba, "getavailablespace", true))
	 {return ((Long) Debug.delegate(ba, "getavailablespace", null));}
RDebugUtils.currentLine=1179648;
 //BA.debugLineNum = 1179648;BA.debugLine="Public Sub GetAvailableSpace As Long";
RDebugUtils.currentLine=1179649;
 //BA.debugLineNum = 1179649;BA.debugLine="Return GetFreeSpace";
if (true) return __ref._getfreespace /*long*/ (null);
RDebugUtils.currentLine=1179650;
 //BA.debugLineNum = 1179650;BA.debugLine="End Sub";
return 0L;
}
public long  _getfreespace(reparto_intmex.keymon.lat.cl_appupdate __ref) throws Exception{
__ref = this;
RDebugUtils.currentModule="cl_appupdate";
if (Debug.shouldDelegate(ba, "getfreespace", true))
	 {return ((Long) Debug.delegate(ba, "getfreespace", null));}
anywheresoftware.b4j.object.JavaObject _jo = null;
RDebugUtils.currentLine=2031616;
 //BA.debugLineNum = 2031616;BA.debugLine="Private Sub GetFreeSpace As Long";
RDebugUtils.currentLine=2031617;
 //BA.debugLineNum = 2031617;BA.debugLine="Dim jo As JavaObject";
_jo = new anywheresoftware.b4j.object.JavaObject();
RDebugUtils.currentLine=2031618;
 //BA.debugLineNum = 2031618;BA.debugLine="jo.InitializeNewInstance(\"java.io.File\", Array(Sh";
_jo.InitializeNewInstance("java.io.File",new Object[]{(Object)(__ref._sharedfolder /*String*/ )});
RDebugUtils.currentLine=2031619;
 //BA.debugLineNum = 2031619;BA.debugLine="Return jo.RunMethod(\"getFreeSpace\", Null)";
if (true) return BA.ObjectToLongNumber(_jo.RunMethod("getFreeSpace",(Object[])(__c.Null)));
RDebugUtils.currentLine=2031620;
 //BA.debugLineNum = 2031620;BA.debugLine="End Sub";
return 0L;
}
public String  _getcurvn(reparto_intmex.keymon.lat.cl_appupdate __ref) throws Exception{
__ref = this;
RDebugUtils.currentModule="cl_appupdate";
if (Debug.shouldDelegate(ba, "getcurvn", true))
	 {return ((String) Debug.delegate(ba, "getcurvn", null));}
RDebugUtils.currentLine=917504;
 //BA.debugLineNum = 917504;BA.debugLine="Public Sub getCurVN As String";
RDebugUtils.currentLine=917505;
 //BA.debugLineNum = 917505;BA.debugLine="Return curver";
if (true) return __ref._curver /*String*/ ;
RDebugUtils.currentLine=917506;
 //BA.debugLineNum = 917506;BA.debugLine="End Sub";
return "";
}
public Object  _getfileuri(reparto_intmex.keymon.lat.cl_appupdate __ref,String _filename) throws Exception{
__ref = this;
RDebugUtils.currentModule="cl_appupdate";
if (Debug.shouldDelegate(ba, "getfileuri", true))
	 {return ((Object) Debug.delegate(ba, "getfileuri", new Object[] {_filename}));}
anywheresoftware.b4j.object.JavaObject _uri = null;
anywheresoftware.b4j.object.JavaObject _f = null;
anywheresoftware.b4j.object.JavaObject _fp = null;
anywheresoftware.b4j.object.JavaObject _context = null;
RDebugUtils.currentLine=2424832;
 //BA.debugLineNum = 2424832;BA.debugLine="Private Sub GetFileUri (FileName As String) As Obj";
RDebugUtils.currentLine=2424833;
 //BA.debugLineNum = 2424833;BA.debugLine="If UseFileProvider = False Then";
if (__ref._usefileprovider /*boolean*/ ==__c.False) { 
RDebugUtils.currentLine=2424834;
 //BA.debugLineNum = 2424834;BA.debugLine="Dim uri As JavaObject";
_uri = new anywheresoftware.b4j.object.JavaObject();
RDebugUtils.currentLine=2424835;
 //BA.debugLineNum = 2424835;BA.debugLine="Return uri.InitializeStatic(\"android.net.Uri\").R";
if (true) return _uri.InitializeStatic("android.net.Uri").RunMethod("parse",new Object[]{(Object)("file://"+__c.File.Combine(__ref._sharedfolder /*String*/ ,_filename))});
 }else {
RDebugUtils.currentLine=2424837;
 //BA.debugLineNum = 2424837;BA.debugLine="Dim f As JavaObject";
_f = new anywheresoftware.b4j.object.JavaObject();
RDebugUtils.currentLine=2424838;
 //BA.debugLineNum = 2424838;BA.debugLine="f.InitializeNewInstance(\"java.io.File\", Array(Sh";
_f.InitializeNewInstance("java.io.File",new Object[]{(Object)(__ref._sharedfolder /*String*/ ),(Object)(_filename)});
RDebugUtils.currentLine=2424839;
 //BA.debugLineNum = 2424839;BA.debugLine="Dim fp As JavaObject";
_fp = new anywheresoftware.b4j.object.JavaObject();
RDebugUtils.currentLine=2424840;
 //BA.debugLineNum = 2424840;BA.debugLine="Dim context As JavaObject";
_context = new anywheresoftware.b4j.object.JavaObject();
RDebugUtils.currentLine=2424841;
 //BA.debugLineNum = 2424841;BA.debugLine="context.InitializeContext";
_context.InitializeContext(ba);
RDebugUtils.currentLine=2424842;
 //BA.debugLineNum = 2424842;BA.debugLine="fp.InitializeStatic(\"android.support.v4.content.";
_fp.InitializeStatic("androidx.core.content.FileProvider");
RDebugUtils.currentLine=2424843;
 //BA.debugLineNum = 2424843;BA.debugLine="Return fp.RunMethod(\"getUriForFile\", Array(conte";
if (true) return _fp.RunMethod("getUriForFile",new Object[]{(Object)(_context.getObject()),(Object)(__c.Application.getPackageName()+".provider"),(Object)(_f.getObject())});
 };
RDebugUtils.currentLine=2424845;
 //BA.debugLineNum = 2424845;BA.debugLine="End Sub";
return null;
}
public String  _getnmappinst(reparto_intmex.keymon.lat.cl_appupdate __ref) throws Exception{
__ref = this;
RDebugUtils.currentModule="cl_appupdate";
if (Debug.shouldDelegate(ba, "getnmappinst", true))
	 {return ((String) Debug.delegate(ba, "getnmappinst", null));}
anywheresoftware.b4j.object.JavaObject _jo = null;
anywheresoftware.b4j.object.JavaObject _context = null;
anywheresoftware.b4j.object.JavaObject _resolver = null;
RDebugUtils.currentLine=2162688;
 //BA.debugLineNum = 2162688;BA.debugLine="Private Sub GetNMAppInst As String";
RDebugUtils.currentLine=2162689;
 //BA.debugLineNum = 2162689;BA.debugLine="Dim jo As JavaObject";
_jo = new anywheresoftware.b4j.object.JavaObject();
RDebugUtils.currentLine=2162690;
 //BA.debugLineNum = 2162690;BA.debugLine="jo.InitializeStatic(\"android.provider.Settings.Se";
_jo.InitializeStatic("android.provider.Settings.Secure");
RDebugUtils.currentLine=2162691;
 //BA.debugLineNum = 2162691;BA.debugLine="Dim context As JavaObject";
_context = new anywheresoftware.b4j.object.JavaObject();
RDebugUtils.currentLine=2162692;
 //BA.debugLineNum = 2162692;BA.debugLine="context.InitializeContext";
_context.InitializeContext(ba);
RDebugUtils.currentLine=2162693;
 //BA.debugLineNum = 2162693;BA.debugLine="Dim resolver As JavaObject = context.RunMethod(\"g";
_resolver = new anywheresoftware.b4j.object.JavaObject();
_resolver = (anywheresoftware.b4j.object.JavaObject) anywheresoftware.b4a.AbsObjectWrapper.ConvertToWrapper(new anywheresoftware.b4j.object.JavaObject(), (java.lang.Object)(_context.RunMethod("getContentResolver",(Object[])(__c.Null))));
RDebugUtils.currentLine=2162694;
 //BA.debugLineNum = 2162694;BA.debugLine="Return jo.RunMethod(\"getString\", Array(resolver,";
if (true) return BA.ObjectToString(_jo.RunMethod("getString",new Object[]{(Object)(_resolver.getObject()),(Object)("install_non_market_apps")}));
RDebugUtils.currentLine=2162695;
 //BA.debugLineNum = 2162695;BA.debugLine="End Sub";
return "";
}
public String  _getpackagename(reparto_intmex.keymon.lat.cl_appupdate __ref) throws Exception{
__ref = this;
RDebugUtils.currentModule="cl_appupdate";
if (Debug.shouldDelegate(ba, "getpackagename", true))
	 {return ((String) Debug.delegate(ba, "getpackagename", null));}
RDebugUtils.currentLine=524288;
 //BA.debugLineNum = 524288;BA.debugLine="Public Sub getPackageName As String";
RDebugUtils.currentLine=524289;
 //BA.debugLineNum = 524289;BA.debugLine="Return sPackageName";
if (true) return __ref._spackagename /*String*/ ;
RDebugUtils.currentLine=524290;
 //BA.debugLineNum = 524290;BA.debugLine="End Sub";
return "";
}
public int  _getsdkversion(reparto_intmex.keymon.lat.cl_appupdate __ref) throws Exception{
__ref = this;
RDebugUtils.currentModule="cl_appupdate";
if (Debug.shouldDelegate(ba, "getsdkversion", true))
	 {return ((Integer) Debug.delegate(ba, "getsdkversion", null));}
anywheresoftware.b4j.object.JavaObject _jo = null;
RDebugUtils.currentLine=2097152;
 //BA.debugLineNum = 2097152;BA.debugLine="Private Sub GetSDKVersion As Int";
RDebugUtils.currentLine=2097153;
 //BA.debugLineNum = 2097153;BA.debugLine="Dim jo As JavaObject";
_jo = new anywheresoftware.b4j.object.JavaObject();
RDebugUtils.currentLine=2097154;
 //BA.debugLineNum = 2097154;BA.debugLine="jo.InitializeStatic(\"android.os.Build.VERSION\")";
_jo.InitializeStatic("android.os.Build.VERSION");
RDebugUtils.currentLine=2097155;
 //BA.debugLineNum = 2097155;BA.debugLine="Return jo.GetField(\"SDK_INT\")";
if (true) return (int)(BA.ObjectToNumber(_jo.GetField("SDK_INT")));
RDebugUtils.currentLine=2097156;
 //BA.debugLineNum = 2097156;BA.debugLine="End Sub";
return 0;
}
public int  _getstatus(reparto_intmex.keymon.lat.cl_appupdate __ref) throws Exception{
__ref = this;
RDebugUtils.currentModule="cl_appupdate";
if (Debug.shouldDelegate(ba, "getstatus", true))
	 {return ((Integer) Debug.delegate(ba, "getstatus", null));}
RDebugUtils.currentLine=851968;
 //BA.debugLineNum = 851968;BA.debugLine="Public Sub getStatus As Int";
RDebugUtils.currentLine=851969;
 //BA.debugLineNum = 851969;BA.debugLine="Return sStatusCode";
if (true) return __ref._sstatuscode /*int*/ ;
RDebugUtils.currentLine=851970;
 //BA.debugLineNum = 851970;BA.debugLine="End Sub";
return 0;
}
public String  _getwebchangelog(reparto_intmex.keymon.lat.cl_appupdate __ref) throws Exception{
__ref = this;
RDebugUtils.currentModule="cl_appupdate";
if (Debug.shouldDelegate(ba, "getwebchangelog", true))
	 {return ((String) Debug.delegate(ba, "getwebchangelog", null));}
RDebugUtils.currentLine=1048576;
 //BA.debugLineNum = 1048576;BA.debugLine="Public Sub getWebChangeLog As String";
RDebugUtils.currentLine=1048577;
 //BA.debugLineNum = 1048577;BA.debugLine="Return webclog";
if (true) return __ref._webclog /*String*/ ;
RDebugUtils.currentLine=1048578;
 //BA.debugLineNum = 1048578;BA.debugLine="End Sub";
return "";
}
public String  _getwebfilesize(reparto_intmex.keymon.lat.cl_appupdate __ref) throws Exception{
__ref = this;
RDebugUtils.currentModule="cl_appupdate";
if (Debug.shouldDelegate(ba, "getwebfilesize", true))
	 {return ((String) Debug.delegate(ba, "getwebfilesize", null));}
RDebugUtils.currentLine=1114112;
 //BA.debugLineNum = 1114112;BA.debugLine="Public Sub getWebFileSize As String";
RDebugUtils.currentLine=1114113;
 //BA.debugLineNum = 1114113;BA.debugLine="Return webfsize";
if (true) return __ref._webfsize /*String*/ ;
RDebugUtils.currentLine=1114114;
 //BA.debugLineNum = 1114114;BA.debugLine="End Sub";
return "";
}
public String  _getwebvn(reparto_intmex.keymon.lat.cl_appupdate __ref) throws Exception{
__ref = this;
RDebugUtils.currentModule="cl_appupdate";
if (Debug.shouldDelegate(ba, "getwebvn", true))
	 {return ((String) Debug.delegate(ba, "getwebvn", null));}
RDebugUtils.currentLine=983040;
 //BA.debugLineNum = 983040;BA.debugLine="Public Sub getWebVN As String";
RDebugUtils.currentLine=983041;
 //BA.debugLineNum = 983041;BA.debugLine="Return webver";
if (true) return __ref._webver /*String*/ ;
RDebugUtils.currentLine=983042;
 //BA.debugLineNum = 983042;BA.debugLine="End Sub";
return "";
}
public String  _initialize(reparto_intmex.keymon.lat.cl_appupdate __ref,anywheresoftware.b4a.BA _ba,Object _callbackmodule,String _eventname) throws Exception{
__ref = this;
innerInitialize(_ba);
RDebugUtils.currentModule="cl_appupdate";
if (Debug.shouldDelegate(ba, "initialize", true))
	 {return ((String) Debug.delegate(ba, "initialize", new Object[] {_ba,_callbackmodule,_eventname}));}
anywheresoftware.b4a.phone.Phone _p = null;
RDebugUtils.currentLine=393216;
 //BA.debugLineNum = 393216;BA.debugLine="Public Sub Initialize(CallbackModule As Object, Ev";
RDebugUtils.currentLine=393217;
 //BA.debugLineNum = 393217;BA.debugLine="Callback = CallbackModule";
__ref._callback /*Object*/  = _callbackmodule;
RDebugUtils.currentLine=393218;
 //BA.debugLineNum = 393218;BA.debugLine="Event = EventName";
__ref._event /*String*/  = _eventname;
RDebugUtils.currentLine=393219;
 //BA.debugLineNum = 393219;BA.debugLine="sPackageName = \"\"";
__ref._spackagename /*String*/  = "";
RDebugUtils.currentLine=393220;
 //BA.debugLineNum = 393220;BA.debugLine="sNewVerTxt = \"\"";
__ref._snewvertxt /*String*/  = "";
RDebugUtils.currentLine=393221;
 //BA.debugLineNum = 393221;BA.debugLine="sNewVerApk = \"\"";
__ref._snewverapk /*String*/  = "";
RDebugUtils.currentLine=393222;
 //BA.debugLineNum = 393222;BA.debugLine="sUserName = \"\"";
__ref._susername /*String*/  = "";
RDebugUtils.currentLine=393223;
 //BA.debugLineNum = 393223;BA.debugLine="sUPassword = \"\"";
__ref._supassword /*String*/  = "";
RDebugUtils.currentLine=393224;
 //BA.debugLineNum = 393224;BA.debugLine="sStatusCode = OK_INIT";
__ref._sstatuscode /*int*/  = __ref._ok_init /*int*/ ;
RDebugUtils.currentLine=393225;
 //BA.debugLineNum = 393225;BA.debugLine="curver = \"\"";
__ref._curver /*String*/  = "";
RDebugUtils.currentLine=393226;
 //BA.debugLineNum = 393226;BA.debugLine="webver = \"\"";
__ref._webver /*String*/  = "";
RDebugUtils.currentLine=393227;
 //BA.debugLineNum = 393227;BA.debugLine="sVerbose = False";
__ref._sverbose /*boolean*/  = __c.False;
RDebugUtils.currentLine=393228;
 //BA.debugLineNum = 393228;BA.debugLine="Dim p As Phone";
_p = new anywheresoftware.b4a.phone.Phone();
RDebugUtils.currentLine=393229;
 //BA.debugLineNum = 393229;BA.debugLine="If p.SdkVersion >= 24 Or File.ExternalWritable =";
if (_p.getSdkVersion()>=24 || __c.File.getExternalWritable()==__c.False) { 
RDebugUtils.currentLine=393230;
 //BA.debugLineNum = 393230;BA.debugLine="UseFileProvider = True";
__ref._usefileprovider /*boolean*/  = __c.True;
RDebugUtils.currentLine=393231;
 //BA.debugLineNum = 393231;BA.debugLine="SharedFolder = File.Combine(File.DirInternal, \"s";
__ref._sharedfolder /*String*/  = __c.File.Combine(__c.File.getDirInternal(),"shared");
RDebugUtils.currentLine=393232;
 //BA.debugLineNum = 393232;BA.debugLine="File.MakeDir(\"\", SharedFolder)";
__c.File.MakeDir("",__ref._sharedfolder /*String*/ );
 }else {
RDebugUtils.currentLine=393234;
 //BA.debugLineNum = 393234;BA.debugLine="UseFileProvider = False";
__ref._usefileprovider /*boolean*/  = __c.False;
RDebugUtils.currentLine=393235;
 //BA.debugLineNum = 393235;BA.debugLine="SharedFolder = rp.GetSafeDirDefaultExternal(\"sha";
__ref._sharedfolder /*String*/  = __ref._rp /*anywheresoftware.b4a.objects.RuntimePermissions*/ .GetSafeDirDefaultExternal("shared");
 };
RDebugUtils.currentLine=393237;
 //BA.debugLineNum = 393237;BA.debugLine="Log($\"SDK#: ${p.SdkVersion} - UseFP: ${UseFilePro";
__c.LogImpl("9393237",("SDK#: "+__c.SmartStringFormatter("",(Object)(_p.getSdkVersion()))+" - UseFP: "+__c.SmartStringFormatter("",(Object)(__ref._usefileprovider /*boolean*/ ))+" - SharedFolder: "+__c.SmartStringFormatter("",(Object)(__ref._sharedfolder /*String*/ ))+""),0);
RDebugUtils.currentLine=393238;
 //BA.debugLineNum = 393238;BA.debugLine="End Sub";
return "";
}
public String  _installapk(reparto_intmex.keymon.lat.cl_appupdate __ref,boolean _pstatus) throws Exception{
__ref = this;
RDebugUtils.currentModule="cl_appupdate";
if (Debug.shouldDelegate(ba, "installapk", true))
	 {return ((String) Debug.delegate(ba, "installapk", new Object[] {_pstatus}));}
RDebugUtils.currentLine=1441792;
 //BA.debugLineNum = 1441792;BA.debugLine="Public Sub InstallApk(pstatus As Boolean)";
RDebugUtils.currentLine=1441793;
 //BA.debugLineNum = 1441793;BA.debugLine="LogColor(\"---- AppUpdating.InstallApk\", LogColor1";
__c.LogImpl("91441793","---- AppUpdating.InstallApk",__ref._logcolor1 /*int*/ );
RDebugUtils.currentLine=1441794;
 //BA.debugLineNum = 1441794;BA.debugLine="If pstatus Then";
if (_pstatus) { 
RDebugUtils.currentLine=1441795;
 //BA.debugLineNum = 1441795;BA.debugLine="SendInstallIntent";
__ref._sendinstallintent /*String*/ (null);
RDebugUtils.currentLine=1441796;
 //BA.debugLineNum = 1441796;BA.debugLine="sStatusCode = OK_INSTALL";
__ref._sstatuscode /*int*/  = __ref._ok_install /*int*/ ;
RDebugUtils.currentLine=1441797;
 //BA.debugLineNum = 1441797;BA.debugLine="If sVerbose Then Log(TAB & \"user asked to instal";
if (__ref._sverbose /*boolean*/ ) { 
__c.LogImpl("91441797",__c.TAB+"user asked to install new apk",0);};
 }else {
RDebugUtils.currentLine=1441799;
 //BA.debugLineNum = 1441799;BA.debugLine="sStatusCode = ERR_NOPERM";
__ref._sstatuscode /*int*/  = __ref._err_noperm /*int*/ ;
RDebugUtils.currentLine=1441800;
 //BA.debugLineNum = 1441800;BA.debugLine="If sVerbose Then Log(TAB & \"no permissions from";
if (__ref._sverbose /*boolean*/ ) { 
__c.LogImpl("91441800",__c.TAB+"no permissions from user to install new apk",0);};
 };
RDebugUtils.currentLine=1441802;
 //BA.debugLineNum = 1441802;BA.debugLine="Finito";
__ref._finito /*String*/ (null);
RDebugUtils.currentLine=1441803;
 //BA.debugLineNum = 1441803;BA.debugLine="End Sub";
return "";
}
public String  _sendinstallintent(reparto_intmex.keymon.lat.cl_appupdate __ref) throws Exception{
__ref = this;
RDebugUtils.currentModule="cl_appupdate";
if (Debug.shouldDelegate(ba, "sendinstallintent", true))
	 {return ((String) Debug.delegate(ba, "sendinstallintent", null));}
String _apkname = "";
anywheresoftware.b4a.objects.IntentWrapper _i = null;
RDebugUtils.currentLine=2359296;
 //BA.debugLineNum = 2359296;BA.debugLine="Private Sub SendInstallIntent";
RDebugUtils.currentLine=2359297;
 //BA.debugLineNum = 2359297;BA.debugLine="Dim ApkName As String = \"tmp.apk\"";
_apkname = "tmp.apk";
RDebugUtils.currentLine=2359298;
 //BA.debugLineNum = 2359298;BA.debugLine="Dim i As Intent";
_i = new anywheresoftware.b4a.objects.IntentWrapper();
RDebugUtils.currentLine=2359299;
 //BA.debugLineNum = 2359299;BA.debugLine="If phone.SdkVersion >= 24 Then													'Nouga";
if (__ref._phone /*anywheresoftware.b4a.phone.Phone*/ .getSdkVersion()>=24) { 
RDebugUtils.currentLine=2359300;
 //BA.debugLineNum = 2359300;BA.debugLine="i.Initialize(\"android.intent.action.INSTALL_PACK";
_i.Initialize("android.intent.action.INSTALL_PACKAGE",BA.ObjectToString(__ref._getfileuri /*Object*/ (null,_apkname)));
RDebugUtils.currentLine=2359301;
 //BA.debugLineNum = 2359301;BA.debugLine="i.Flags = Bit.Or(i.Flags, 1) 'FLAG_GRANT_READ_UR";
_i.setFlags(__c.Bit.Or(_i.getFlags(),(int) (1)));
 }else {
RDebugUtils.currentLine=2359303;
 //BA.debugLineNum = 2359303;BA.debugLine="i.Initialize(i.ACTION_VIEW, \"file://\" & File.Com";
_i.Initialize(_i.ACTION_VIEW,"file://"+__c.File.Combine(__ref._sharedfolder /*String*/ ,_apkname));
RDebugUtils.currentLine=2359304;
 //BA.debugLineNum = 2359304;BA.debugLine="i.SetType(\"application/vnd.android.package-archi";
_i.SetType("application/vnd.android.package-archive");
 };
RDebugUtils.currentLine=2359306;
 //BA.debugLineNum = 2359306;BA.debugLine="StartActivity(i)";
__c.StartActivity(ba,(Object)(_i.getObject()));
RDebugUtils.currentLine=2359307;
 //BA.debugLineNum = 2359307;BA.debugLine="End Sub";
return "";
}
public boolean  _isvalidcv(reparto_intmex.keymon.lat.cl_appupdate __ref) throws Exception{
__ref = this;
RDebugUtils.currentModule="cl_appupdate";
if (Debug.shouldDelegate(ba, "isvalidcv", true))
	 {return ((Boolean) Debug.delegate(ba, "isvalidcv", null));}
anywheresoftware.b4a.phone.PackageManagerWrapper _pm = null;
RDebugUtils.currentLine=1703936;
 //BA.debugLineNum = 1703936;BA.debugLine="Private Sub IsValidCV As Boolean";
RDebugUtils.currentLine=1703937;
 //BA.debugLineNum = 1703937;BA.debugLine="If sPackageName = \"\" Then";
if ((__ref._spackagename /*String*/ ).equals("")) { 
RDebugUtils.currentLine=1703938;
 //BA.debugLineNum = 1703938;BA.debugLine="curver = \"\"";
__ref._curver /*String*/  = "";
RDebugUtils.currentLine=1703939;
 //BA.debugLineNum = 1703939;BA.debugLine="sStatusCode = ERR_NOPKG";
__ref._sstatuscode /*int*/  = __ref._err_nopkg /*int*/ ;
RDebugUtils.currentLine=1703940;
 //BA.debugLineNum = 1703940;BA.debugLine="If sVerbose Then Log($\"${TAB}missing package nam";
if (__ref._sverbose /*boolean*/ ) { 
__c.LogImpl("91703940",(""+__c.SmartStringFormatter("",(Object)(__c.TAB))+"missing package name for current version check"),0);};
 }else {
RDebugUtils.currentLine=1703942;
 //BA.debugLineNum = 1703942;BA.debugLine="Dim pm As PackageManager";
_pm = new anywheresoftware.b4a.phone.PackageManagerWrapper();
RDebugUtils.currentLine=1703943;
 //BA.debugLineNum = 1703943;BA.debugLine="curver = pm.GetVersionName(sPackageName)";
__ref._curver /*String*/  = _pm.GetVersionName(__ref._spackagename /*String*/ );
RDebugUtils.currentLine=1703944;
 //BA.debugLineNum = 1703944;BA.debugLine="sStatusCode = OK_CURVER 									'got current ve";
__ref._sstatuscode /*int*/  = __ref._ok_curver /*int*/ ;
RDebugUtils.currentLine=1703945;
 //BA.debugLineNum = 1703945;BA.debugLine="If sVerbose Then Log($\"${TAB}Current Version: ${";
if (__ref._sverbose /*boolean*/ ) { 
__c.LogImpl("91703945",(""+__c.SmartStringFormatter("",(Object)(__c.TAB))+"Current Version: "+__c.SmartStringFormatter("",(Object)(__ref._curver /*String*/ ))+""),0);};
 };
RDebugUtils.currentLine=1703947;
 //BA.debugLineNum = 1703947;BA.debugLine="Return (sStatusCode == OK_CURVER)";
if (true) return (__ref._sstatuscode /*int*/ ==__ref._ok_curver /*int*/ );
RDebugUtils.currentLine=1703948;
 //BA.debugLineNum = 1703948;BA.debugLine="End Sub";
return false;
}
public anywheresoftware.b4a.keywords.Common.ResumableSubWrapper  _isvalidwv(reparto_intmex.keymon.lat.cl_appupdate __ref) throws Exception{
RDebugUtils.currentModule="cl_appupdate";
if (Debug.shouldDelegate(ba, "isvalidwv", true))
	 {return ((anywheresoftware.b4a.keywords.Common.ResumableSubWrapper) Debug.delegate(ba, "isvalidwv", null));}
ResumableSub_IsvalidWV rsub = new ResumableSub_IsvalidWV(this,__ref);
rsub.resume(ba, null);
return (anywheresoftware.b4a.keywords.Common.ResumableSubWrapper) anywheresoftware.b4a.AbsObjectWrapper.ConvertToWrapper(new anywheresoftware.b4a.keywords.Common.ResumableSubWrapper(), rsub);
}
public static class ResumableSub_IsvalidWV extends BA.ResumableSub {
public ResumableSub_IsvalidWV(reparto_intmex.keymon.lat.cl_appupdate parent,reparto_intmex.keymon.lat.cl_appupdate __ref) {
this.parent = parent;
this.__ref = __ref;
this.__ref = parent;
}
reparto_intmex.keymon.lat.cl_appupdate __ref;
reparto_intmex.keymon.lat.cl_appupdate parent;
reparto_intmex.keymon.lat.httpjob _j = null;

@Override
public void resume(BA ba, Object[] result) throws Exception{
RDebugUtils.currentModule="cl_appupdate";

    while (true) {
        switch (state) {
            case -1:
{
parent.__c.ReturnFromResumableSub(this,null);return;}
case 0:
//C
this.state = 1;
RDebugUtils.currentLine=1769473;
 //BA.debugLineNum = 1769473;BA.debugLine="Log(\"IsValidComplete start\")";
parent.__c.LogImpl("91769473","IsValidComplete start",0);
RDebugUtils.currentLine=1769474;
 //BA.debugLineNum = 1769474;BA.debugLine="If sNewVerTxt = \"\" Then";
if (true) break;

case 1:
//if
this.state = 60;
if ((__ref._snewvertxt /*String*/ ).equals("")) { 
this.state = 3;
}else {
this.state = 11;
}if (true) break;

case 3:
//C
this.state = 4;
RDebugUtils.currentLine=1769475;
 //BA.debugLineNum = 1769475;BA.debugLine="webver = \"\"";
__ref._webver /*String*/  = "";
RDebugUtils.currentLine=1769476;
 //BA.debugLineNum = 1769476;BA.debugLine="sStatusCode = ERR_NOTXT";
__ref._sstatuscode /*int*/  = __ref._err_notxt /*int*/ ;
RDebugUtils.currentLine=1769477;
 //BA.debugLineNum = 1769477;BA.debugLine="If sVerbose Then Log($\"${TAB}missing info file f";
if (true) break;

case 4:
//if
this.state = 9;
if (__ref._sverbose /*boolean*/ ) { 
this.state = 6;
;}if (true) break;

case 6:
//C
this.state = 9;
parent.__c.LogImpl("91769477",(""+parent.__c.SmartStringFormatter("",(Object)(parent.__c.TAB))+"missing info file full path indication"),0);
if (true) break;

case 9:
//C
this.state = 60;
;
 if (true) break;

case 11:
//C
this.state = 12;
RDebugUtils.currentLine=1769480;
 //BA.debugLineNum = 1769480;BA.debugLine="Dim j As HttpJob";
_j = new reparto_intmex.keymon.lat.httpjob();
RDebugUtils.currentLine=1769481;
 //BA.debugLineNum = 1769481;BA.debugLine="j.Initialize(\"\", Me)";
_j._initialize /*String*/ (null,ba,"",parent);
RDebugUtils.currentLine=1769482;
 //BA.debugLineNum = 1769482;BA.debugLine="j.Username = sUserName";
_j._username /*String*/  = __ref._susername /*String*/ ;
RDebugUtils.currentLine=1769483;
 //BA.debugLineNum = 1769483;BA.debugLine="j.Password = sUPassword";
_j._password /*String*/  = __ref._supassword /*String*/ ;
RDebugUtils.currentLine=1769484;
 //BA.debugLineNum = 1769484;BA.debugLine="j.Download(sNewVerTxt)								'ex: jobapk.Downlo";
_j._download /*String*/ (null,__ref._snewvertxt /*String*/ );
RDebugUtils.currentLine=1769485;
 //BA.debugLineNum = 1769485;BA.debugLine="Log(\"before\")";
parent.__c.LogImpl("91769485","before",0);
RDebugUtils.currentLine=1769486;
 //BA.debugLineNum = 1769486;BA.debugLine="Wait For (j) JobDone(j As HttpJob)";
parent.__c.WaitFor("jobdone", ba, new anywheresoftware.b4a.shell.DebugResumableSub.DelegatableResumableSub(this, "cl_appupdate", "isvalidwv"), (Object)(_j));
this.state = 61;
return;
case 61:
//C
this.state = 12;
_j = (reparto_intmex.keymon.lat.httpjob) result[1];
;
RDebugUtils.currentLine=1769487;
 //BA.debugLineNum = 1769487;BA.debugLine="Log(\"after\")";
parent.__c.LogImpl("91769487","after",0);
RDebugUtils.currentLine=1769488;
 //BA.debugLineNum = 1769488;BA.debugLine="If j.Success Then";
if (true) break;

case 12:
//if
this.state = 59;
if (_j._success /*boolean*/ ) { 
this.state = 14;
}else {
this.state = 52;
}if (true) break;

case 14:
//C
this.state = 15;
RDebugUtils.currentLine=1769489;
 //BA.debugLineNum = 1769489;BA.debugLine="If sVerbose Then Log($\"Webserver's info file co";
if (true) break;

case 15:
//if
this.state = 20;
if (__ref._sverbose /*boolean*/ ) { 
this.state = 17;
;}if (true) break;

case 17:
//C
this.state = 20;
parent.__c.LogImpl("91769489",("Webserver's info file content: "+parent.__c.SmartStringFormatter("",(Object)(parent.__c.CRLF))+""+parent.__c.SmartStringFormatter("",(Object)(_j._getstring /*String*/ (null)))+""),0);
if (true) break;

case 20:
//C
this.state = 21;
;
RDebugUtils.currentLine=1769490;
 //BA.debugLineNum = 1769490;BA.debugLine="If Not(J.GetString.Contains(\"<!DOCTYPE html>\"))";
if (true) break;

case 21:
//if
this.state = 50;
if (parent.__c.Not(_j._getstring /*String*/ (null).contains("<!DOCTYPE html>"))) { 
this.state = 23;
}else {
this.state = 43;
}if (true) break;

case 23:
//C
this.state = 24;
RDebugUtils.currentLine=1769491;
 //BA.debugLineNum = 1769491;BA.debugLine="webver = ExtractVN(J.GetString)";
__ref._webver /*String*/  = __ref._extractvn /*String*/ (null,_j._getstring /*String*/ (null));
RDebugUtils.currentLine=1769492;
 //BA.debugLineNum = 1769492;BA.debugLine="webclog = ExtractCL(J.GetString)					'optional";
__ref._webclog /*String*/  = __ref._extractcl /*String*/ (null,_j._getstring /*String*/ (null));
RDebugUtils.currentLine=1769493;
 //BA.debugLineNum = 1769493;BA.debugLine="webfsize = ExtractSZ(J.GetString)					'optiona";
__ref._webfsize /*String*/  = __ref._extractsz /*String*/ (null,_j._getstring /*String*/ (null));
RDebugUtils.currentLine=1769494;
 //BA.debugLineNum = 1769494;BA.debugLine="If webver = \"\" Then";
if (true) break;

case 24:
//if
this.state = 41;
if ((__ref._webver /*String*/ ).equals("")) { 
this.state = 26;
}else {
this.state = 34;
}if (true) break;

case 26:
//C
this.state = 27;
RDebugUtils.currentLine=1769495;
 //BA.debugLineNum = 1769495;BA.debugLine="sStatusCode = ERR_TXTROW";
__ref._sstatuscode /*int*/  = __ref._err_txtrow /*int*/ ;
RDebugUtils.currentLine=1769496;
 //BA.debugLineNum = 1769496;BA.debugLine="If sVerbose Then Log($\"${TAB}wrong row format";
if (true) break;

case 27:
//if
this.state = 32;
if (__ref._sverbose /*boolean*/ ) { 
this.state = 29;
;}if (true) break;

case 29:
//C
this.state = 32;
parent.__c.LogImpl("91769496",(""+parent.__c.SmartStringFormatter("",(Object)(parent.__c.TAB))+"wrong row format in info file "),0);
if (true) break;

case 32:
//C
this.state = 41;
;
 if (true) break;

case 34:
//C
this.state = 35;
RDebugUtils.currentLine=1769498;
 //BA.debugLineNum = 1769498;BA.debugLine="sStatusCode = OK_WEBVER							'read apk's ver";
__ref._sstatuscode /*int*/  = __ref._ok_webver /*int*/ ;
RDebugUtils.currentLine=1769499;
 //BA.debugLineNum = 1769499;BA.debugLine="If sVerbose Then Log($\"${TAB}Web version numb";
if (true) break;

case 35:
//if
this.state = 40;
if (__ref._sverbose /*boolean*/ ) { 
this.state = 37;
;}if (true) break;

case 37:
//C
this.state = 40;
parent.__c.LogImpl("91769499",(""+parent.__c.SmartStringFormatter("",(Object)(parent.__c.TAB))+"Web version number: "+parent.__c.SmartStringFormatter("",(Object)(__ref._webver /*String*/ ))+""),0);
if (true) break;

case 40:
//C
this.state = 41;
;
 if (true) break;

case 41:
//C
this.state = 50;
;
 if (true) break;

case 43:
//C
this.state = 44;
RDebugUtils.currentLine=1769502;
 //BA.debugLineNum = 1769502;BA.debugLine="sStatusCode = ERR_HTML								'website returne";
__ref._sstatuscode /*int*/  = __ref._err_html /*int*/ ;
RDebugUtils.currentLine=1769503;
 //BA.debugLineNum = 1769503;BA.debugLine="If sVerbose Then Log($\"${TAB}ERROR: website re";
if (true) break;

case 44:
//if
this.state = 49;
if (__ref._sverbose /*boolean*/ ) { 
this.state = 46;
;}if (true) break;

case 46:
//C
this.state = 49;
parent.__c.LogImpl("91769503",(""+parent.__c.SmartStringFormatter("",(Object)(parent.__c.TAB))+"ERROR: website returned an HTML error page"),0);
if (true) break;

case 49:
//C
this.state = 50;
;
 if (true) break;

case 50:
//C
this.state = 59;
;
 if (true) break;

case 52:
//C
this.state = 53;
RDebugUtils.currentLine=1769506;
 //BA.debugLineNum = 1769506;BA.debugLine="Log($\"${TAB}Error: ${J.ErrorMessage}\"$)";
parent.__c.LogImpl("91769506",(""+parent.__c.SmartStringFormatter("",(Object)(parent.__c.TAB))+"Error: "+parent.__c.SmartStringFormatter("",(Object)(_j._errormessage /*String*/ ))+""),0);
RDebugUtils.currentLine=1769507;
 //BA.debugLineNum = 1769507;BA.debugLine="sStatusCode = ERR_HTTP";
__ref._sstatuscode /*int*/  = __ref._err_http /*int*/ ;
RDebugUtils.currentLine=1769508;
 //BA.debugLineNum = 1769508;BA.debugLine="If sVerbose Then Log($\"${TAB}error in httputils";
if (true) break;

case 53:
//if
this.state = 58;
if (__ref._sverbose /*boolean*/ ) { 
this.state = 55;
;}if (true) break;

case 55:
//C
this.state = 58;
parent.__c.LogImpl("91769508",(""+parent.__c.SmartStringFormatter("",(Object)(parent.__c.TAB))+"error in httputils2"),0);
if (true) break;

case 58:
//C
this.state = 59;
;
RDebugUtils.currentLine=1769509;
 //BA.debugLineNum = 1769509;BA.debugLine="ToastMessageShow(\"Error: \" & J.ErrorMessage, Tr";
parent.__c.ToastMessageShow(BA.ObjectToCharSequence("Error: "+_j._errormessage /*String*/ ),parent.__c.True);
 if (true) break;

case 59:
//C
this.state = 60;
;
RDebugUtils.currentLine=1769511;
 //BA.debugLineNum = 1769511;BA.debugLine="j.Release";
_j._release /*String*/ (null);
 if (true) break;

case 60:
//C
this.state = -1;
;
RDebugUtils.currentLine=1769513;
 //BA.debugLineNum = 1769513;BA.debugLine="Return (sStatusCode == OK_WEBVER)";
if (true) {
parent.__c.ReturnFromResumableSub(this,(Object)((__ref._sstatuscode /*int*/ ==__ref._ok_webver /*int*/ )));return;};
RDebugUtils.currentLine=1769514;
 //BA.debugLineNum = 1769514;BA.debugLine="End Sub";
if (true) break;

            }
        }
    }
}
public String  _readcurvn(reparto_intmex.keymon.lat.cl_appupdate __ref) throws Exception{
__ref = this;
RDebugUtils.currentModule="cl_appupdate";
if (Debug.shouldDelegate(ba, "readcurvn", true))
	 {return ((String) Debug.delegate(ba, "readcurvn", null));}
RDebugUtils.currentLine=1245184;
 //BA.debugLineNum = 1245184;BA.debugLine="Public Sub ReadCurVN";
RDebugUtils.currentLine=1245185;
 //BA.debugLineNum = 1245185;BA.debugLine="LogColor(\"---- AppUpdating.ReadCurVN\", LogColor1)";
__c.LogImpl("91245185","---- AppUpdating.ReadCurVN",__ref._logcolor1 /*int*/ );
RDebugUtils.currentLine=1245186;
 //BA.debugLineNum = 1245186;BA.debugLine="IsValidCV											'we don't care about its resu";
__ref._isvalidcv /*boolean*/ (null);
RDebugUtils.currentLine=1245187;
 //BA.debugLineNum = 1245187;BA.debugLine="Finito";
__ref._finito /*String*/ (null);
RDebugUtils.currentLine=1245188;
 //BA.debugLineNum = 1245188;BA.debugLine="End Sub";
return "";
}
public void  _readwebvn(reparto_intmex.keymon.lat.cl_appupdate __ref) throws Exception{
RDebugUtils.currentModule="cl_appupdate";
if (Debug.shouldDelegate(ba, "readwebvn", true))
	 {Debug.delegate(ba, "readwebvn", null); return;}
ResumableSub_ReadWebVN rsub = new ResumableSub_ReadWebVN(this,__ref);
rsub.resume(ba, null);
}
public static class ResumableSub_ReadWebVN extends BA.ResumableSub {
public ResumableSub_ReadWebVN(reparto_intmex.keymon.lat.cl_appupdate parent,reparto_intmex.keymon.lat.cl_appupdate __ref) {
this.parent = parent;
this.__ref = __ref;
this.__ref = parent;
}
reparto_intmex.keymon.lat.cl_appupdate __ref;
reparto_intmex.keymon.lat.cl_appupdate parent;
boolean _okwebver = false;

@Override
public void resume(BA ba, Object[] result) throws Exception{
RDebugUtils.currentModule="cl_appupdate";

    while (true) {
        switch (state) {
            case -1:
return;

case 0:
//C
this.state = -1;
RDebugUtils.currentLine=1310721;
 //BA.debugLineNum = 1310721;BA.debugLine="LogColor(\"---- AppUpdating.ReadWebVN\", LogColor1)";
parent.__c.LogImpl("91310721","---- AppUpdating.ReadWebVN",__ref._logcolor1 /*int*/ );
RDebugUtils.currentLine=1310722;
 //BA.debugLineNum = 1310722;BA.debugLine="Wait For(IsvalidWV) Complete (OkWebVer As Boolean";
parent.__c.WaitFor("complete", ba, new anywheresoftware.b4a.shell.DebugResumableSub.DelegatableResumableSub(this, "cl_appupdate", "readwebvn"), __ref._isvalidwv /*anywheresoftware.b4a.keywords.Common.ResumableSubWrapper*/ (null));
this.state = 1;
return;
case 1:
//C
this.state = -1;
_okwebver = (Boolean) result[1];
;
RDebugUtils.currentLine=1310723;
 //BA.debugLineNum = 1310723;BA.debugLine="Finito";
__ref._finito /*String*/ (null);
RDebugUtils.currentLine=1310724;
 //BA.debugLineNum = 1310724;BA.debugLine="End Sub";
if (true) break;

            }
        }
    }
}
public String  _setandstartsplashscreen(reparto_intmex.keymon.lat.cl_appupdate __ref,anywheresoftware.b4a.objects.ActivityWrapper _callingact,anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _bm) throws Exception{
__ref = this;
RDebugUtils.currentModule="cl_appupdate";
if (Debug.shouldDelegate(ba, "setandstartsplashscreen", true))
	 {return ((String) Debug.delegate(ba, "setandstartsplashscreen", new Object[] {_callingact,_bm}));}
anywheresoftware.b4a.objects.drawable.BitmapDrawable _bitimage = null;
RDebugUtils.currentLine=2555904;
 //BA.debugLineNum = 2555904;BA.debugLine="Public Sub SetAndStartSplashScreen(CallingAct As A";
RDebugUtils.currentLine=2555905;
 //BA.debugLineNum = 2555905;BA.debugLine="If BM.IsInitialized Then";
if (_bm.IsInitialized()) { 
RDebugUtils.currentLine=2555906;
 //BA.debugLineNum = 2555906;BA.debugLine="pnlSplash.Initialize(\"pnl1\")";
__ref._pnlsplash /*anywheresoftware.b4a.objects.PanelWrapper*/ .Initialize(ba,"pnl1");
RDebugUtils.currentLine=2555907;
 //BA.debugLineNum = 2555907;BA.debugLine="pnlSplash.Tag = \"splash\"";
__ref._pnlsplash /*anywheresoftware.b4a.objects.PanelWrapper*/ .setTag((Object)("splash"));
RDebugUtils.currentLine=2555908;
 //BA.debugLineNum = 2555908;BA.debugLine="Dim BitImage As BitmapDrawable";
_bitimage = new anywheresoftware.b4a.objects.drawable.BitmapDrawable();
RDebugUtils.currentLine=2555909;
 //BA.debugLineNum = 2555909;BA.debugLine="BitImage.Initialize(BM)";
_bitimage.Initialize((android.graphics.Bitmap)(_bm.getObject()));
RDebugUtils.currentLine=2555910;
 //BA.debugLineNum = 2555910;BA.debugLine="BitImage.Gravity = Gravity.FILL";
_bitimage.setGravity(__c.Gravity.FILL);
RDebugUtils.currentLine=2555911;
 //BA.debugLineNum = 2555911;BA.debugLine="CallingAct.AddView(pnlSplash, 0, 0, CallingAct.W";
_callingact.AddView((android.view.View)(__ref._pnlsplash /*anywheresoftware.b4a.objects.PanelWrapper*/ .getObject()),(int) (0),(int) (0),_callingact.getWidth(),_callingact.getHeight());
RDebugUtils.currentLine=2555912;
 //BA.debugLineNum = 2555912;BA.debugLine="pnlSplash.Background = BitImage";
__ref._pnlsplash /*anywheresoftware.b4a.objects.PanelWrapper*/ .setBackground((android.graphics.drawable.Drawable)(_bitimage.getObject()));
RDebugUtils.currentLine=2555913;
 //BA.debugLineNum = 2555913;BA.debugLine="pnlSplash.BringToFront";
__ref._pnlsplash /*anywheresoftware.b4a.objects.PanelWrapper*/ .BringToFront();
RDebugUtils.currentLine=2555914;
 //BA.debugLineNum = 2555914;BA.debugLine="SplashShowing = True";
__ref._splashshowing /*boolean*/  = __c.True;
 };
RDebugUtils.currentLine=2555916;
 //BA.debugLineNum = 2555916;BA.debugLine="End Sub";
return "";
}
public String  _setcredentials(reparto_intmex.keymon.lat.cl_appupdate __ref,String _usern,String _userp) throws Exception{
__ref = this;
RDebugUtils.currentModule="cl_appupdate";
if (Debug.shouldDelegate(ba, "setcredentials", true))
	 {return ((String) Debug.delegate(ba, "setcredentials", new Object[] {_usern,_userp}));}
RDebugUtils.currentLine=720896;
 //BA.debugLineNum = 720896;BA.debugLine="Public Sub setCredentials(UserN As String, UserP A";
RDebugUtils.currentLine=720897;
 //BA.debugLineNum = 720897;BA.debugLine="sUserName = UserN";
__ref._susername /*String*/  = _usern;
RDebugUtils.currentLine=720898;
 //BA.debugLineNum = 720898;BA.debugLine="sUPassword = UserP";
__ref._supassword /*String*/  = _userp;
RDebugUtils.currentLine=720899;
 //BA.debugLineNum = 720899;BA.debugLine="End Sub";
return "";
}
public String  _setfileuriasintentdata(reparto_intmex.keymon.lat.cl_appupdate __ref,anywheresoftware.b4a.objects.IntentWrapper _intent,String _filename) throws Exception{
__ref = this;
RDebugUtils.currentModule="cl_appupdate";
if (Debug.shouldDelegate(ba, "setfileuriasintentdata", true))
	 {return ((String) Debug.delegate(ba, "setfileuriasintentdata", new Object[] {_intent,_filename}));}
anywheresoftware.b4j.object.JavaObject _jo = null;
RDebugUtils.currentLine=2490368;
 //BA.debugLineNum = 2490368;BA.debugLine="Private Sub SetFileUriAsIntentData (Intent As Inte";
RDebugUtils.currentLine=2490369;
 //BA.debugLineNum = 2490369;BA.debugLine="Dim jo As JavaObject = Intent";
_jo = new anywheresoftware.b4j.object.JavaObject();
_jo = (anywheresoftware.b4j.object.JavaObject) anywheresoftware.b4a.AbsObjectWrapper.ConvertToWrapper(new anywheresoftware.b4j.object.JavaObject(), (java.lang.Object)(_intent.getObject()));
RDebugUtils.currentLine=2490370;
 //BA.debugLineNum = 2490370;BA.debugLine="jo.RunMethod(\"setData\", Array(GetFileUri(FileName";
_jo.RunMethod("setData",new Object[]{__ref._getfileuri /*Object*/ (null,_filename)});
RDebugUtils.currentLine=2490371;
 //BA.debugLineNum = 2490371;BA.debugLine="Intent.Flags = Bit.Or(Intent.Flags, 1) 'FLAG_GRAN";
_intent.setFlags(__c.Bit.Or(_intent.getFlags(),(int) (1)));
RDebugUtils.currentLine=2490372;
 //BA.debugLineNum = 2490372;BA.debugLine="End Sub";
return "";
}
public String  _setnewverapk(reparto_intmex.keymon.lat.cl_appupdate __ref,String _nva) throws Exception{
__ref = this;
RDebugUtils.currentModule="cl_appupdate";
if (Debug.shouldDelegate(ba, "setnewverapk", true))
	 {return ((String) Debug.delegate(ba, "setnewverapk", new Object[] {_nva}));}
RDebugUtils.currentLine=655360;
 //BA.debugLineNum = 655360;BA.debugLine="Public Sub setNewVerApk(NVA As String)";
RDebugUtils.currentLine=655361;
 //BA.debugLineNum = 655361;BA.debugLine="sNewVerApk = NVA";
__ref._snewverapk /*String*/  = _nva;
RDebugUtils.currentLine=655362;
 //BA.debugLineNum = 655362;BA.debugLine="End Sub";
return "";
}
public String  _setnewvertxt(reparto_intmex.keymon.lat.cl_appupdate __ref,String _nvt) throws Exception{
__ref = this;
RDebugUtils.currentModule="cl_appupdate";
if (Debug.shouldDelegate(ba, "setnewvertxt", true))
	 {return ((String) Debug.delegate(ba, "setnewvertxt", new Object[] {_nvt}));}
RDebugUtils.currentLine=589824;
 //BA.debugLineNum = 589824;BA.debugLine="Public Sub setNewVerTxt(NVT As String)";
RDebugUtils.currentLine=589825;
 //BA.debugLineNum = 589825;BA.debugLine="sNewVerTxt = NVT";
__ref._snewvertxt /*String*/  = _nvt;
RDebugUtils.currentLine=589826;
 //BA.debugLineNum = 589826;BA.debugLine="End Sub";
return "";
}
public String  _setpackagename(reparto_intmex.keymon.lat.cl_appupdate __ref,String _pn) throws Exception{
__ref = this;
RDebugUtils.currentModule="cl_appupdate";
if (Debug.shouldDelegate(ba, "setpackagename", true))
	 {return ((String) Debug.delegate(ba, "setpackagename", new Object[] {_pn}));}
RDebugUtils.currentLine=458752;
 //BA.debugLineNum = 458752;BA.debugLine="Public Sub setPackageName(PN As String)";
RDebugUtils.currentLine=458753;
 //BA.debugLineNum = 458753;BA.debugLine="sPackageName = PN";
__ref._spackagename /*String*/  = _pn;
RDebugUtils.currentLine=458754;
 //BA.debugLineNum = 458754;BA.debugLine="End Sub";
return "";
}
public String  _setverbose(reparto_intmex.keymon.lat.cl_appupdate __ref,boolean _verbose) throws Exception{
__ref = this;
RDebugUtils.currentModule="cl_appupdate";
if (Debug.shouldDelegate(ba, "setverbose", true))
	 {return ((String) Debug.delegate(ba, "setverbose", new Object[] {_verbose}));}
RDebugUtils.currentLine=786432;
 //BA.debugLineNum = 786432;BA.debugLine="Public Sub setVerbose(Verbose As Boolean)";
RDebugUtils.currentLine=786433;
 //BA.debugLineNum = 786433;BA.debugLine="sVerbose = Verbose";
__ref._sverbose /*boolean*/  = _verbose;
RDebugUtils.currentLine=786434;
 //BA.debugLineNum = 786434;BA.debugLine="newinst2.svcVerbose = Verbose";
_newinst2._svcverbose /*boolean*/  = _verbose;
RDebugUtils.currentLine=786435;
 //BA.debugLineNum = 786435;BA.debugLine="End Sub";
return "";
}
public String  _stopsplashscreen(reparto_intmex.keymon.lat.cl_appupdate __ref) throws Exception{
__ref = this;
RDebugUtils.currentModule="cl_appupdate";
if (Debug.shouldDelegate(ba, "stopsplashscreen", true))
	 {return ((String) Debug.delegate(ba, "stopsplashscreen", null));}
RDebugUtils.currentLine=2621440;
 //BA.debugLineNum = 2621440;BA.debugLine="Public Sub StopSplashScreen";
RDebugUtils.currentLine=2621441;
 //BA.debugLineNum = 2621441;BA.debugLine="If SplashShowing Then";
if (__ref._splashshowing /*boolean*/ ) { 
RDebugUtils.currentLine=2621442;
 //BA.debugLineNum = 2621442;BA.debugLine="SplashShowing = False";
__ref._splashshowing /*boolean*/  = __c.False;
RDebugUtils.currentLine=2621443;
 //BA.debugLineNum = 2621443;BA.debugLine="pnlSplash.RemoveView";
__ref._pnlsplash /*anywheresoftware.b4a.objects.PanelWrapper*/ .RemoveView();
 };
RDebugUtils.currentLine=2621445;
 //BA.debugLineNum = 2621445;BA.debugLine="End Sub";
return "";
}
public void  _tryapkupdate(reparto_intmex.keymon.lat.cl_appupdate __ref) throws Exception{
RDebugUtils.currentModule="cl_appupdate";
if (Debug.shouldDelegate(ba, "tryapkupdate", true))
	 {Debug.delegate(ba, "tryapkupdate", null); return;}
ResumableSub_TryApkUpdate rsub = new ResumableSub_TryApkUpdate(this,__ref);
rsub.resume(ba, null);
}
public static class ResumableSub_TryApkUpdate extends BA.ResumableSub {
public ResumableSub_TryApkUpdate(reparto_intmex.keymon.lat.cl_appupdate parent,reparto_intmex.keymon.lat.cl_appupdate __ref) {
this.parent = parent;
this.__ref = __ref;
this.__ref = parent;
}
reparto_intmex.keymon.lat.cl_appupdate __ref;
reparto_intmex.keymon.lat.cl_appupdate parent;
reparto_intmex.keymon.lat.httpjob _j = null;
anywheresoftware.b4a.objects.streams.File.OutputStreamWrapper _out = null;

@Override
public void resume(BA ba, Object[] result) throws Exception{
RDebugUtils.currentModule="cl_appupdate";

    while (true) {
try {

        switch (state) {
            case -1:
return;

case 0:
//C
this.state = 1;
RDebugUtils.currentLine=1572865;
 //BA.debugLineNum = 1572865;BA.debugLine="LogColor($\"${TAB}-- TryApkUpdate\"$, LogColor1)";
parent.__c.LogImpl("91572865",(""+parent.__c.SmartStringFormatter("",(Object)(parent.__c.TAB))+"-- TryApkUpdate"),__ref._logcolor1 /*int*/ );
RDebugUtils.currentLine=1572867;
 //BA.debugLineNum = 1572867;BA.debugLine="If ((sStatusCode >= 0) And (sStatusCode <> NO_NEW";
if (true) break;

case 1:
//if
this.state = 44;
if (((__ref._sstatuscode /*int*/ >=0) && (__ref._sstatuscode /*int*/ !=__ref._no_newerapk /*int*/ ))) { 
this.state = 3;
}if (true) break;

case 3:
//C
this.state = 4;
RDebugUtils.currentLine=1572869;
 //BA.debugLineNum = 1572869;BA.debugLine="Dim j As HttpJob";
_j = new reparto_intmex.keymon.lat.httpjob();
RDebugUtils.currentLine=1572870;
 //BA.debugLineNum = 1572870;BA.debugLine="j.Initialize(\"\", Me)";
_j._initialize /*String*/ (null,ba,"",parent);
RDebugUtils.currentLine=1572871;
 //BA.debugLineNum = 1572871;BA.debugLine="j.Username = sUserName";
_j._username /*String*/  = __ref._susername /*String*/ ;
RDebugUtils.currentLine=1572872;
 //BA.debugLineNum = 1572872;BA.debugLine="j.Password = sUPassword";
_j._password /*String*/  = __ref._supassword /*String*/ ;
RDebugUtils.currentLine=1572873;
 //BA.debugLineNum = 1572873;BA.debugLine="j.Download(sNewVerApk)								'ex: jobapk.Downlo";
_j._download /*String*/ (null,__ref._snewverapk /*String*/ );
RDebugUtils.currentLine=1572874;
 //BA.debugLineNum = 1572874;BA.debugLine="Wait For (j) JobDone(j As HttpJob)";
parent.__c.WaitFor("jobdone", ba, new anywheresoftware.b4a.shell.DebugResumableSub.DelegatableResumableSub(this, "cl_appupdate", "tryapkupdate"), (Object)(_j));
this.state = 45;
return;
case 45:
//C
this.state = 4;
_j = (reparto_intmex.keymon.lat.httpjob) result[1];
;
RDebugUtils.currentLine=1572875;
 //BA.debugLineNum = 1572875;BA.debugLine="Log($\"Donload ok? ${j.Success}\"$)";
parent.__c.LogImpl("91572875",("Donload ok? "+parent.__c.SmartStringFormatter("",(Object)(_j._success /*boolean*/ ))+""),0);
RDebugUtils.currentLine=1572876;
 //BA.debugLineNum = 1572876;BA.debugLine="If j.Success Then";
if (true) break;

case 4:
//if
this.state = 33;
if (_j._success /*boolean*/ ) { 
this.state = 6;
}else {
this.state = 26;
}if (true) break;

case 6:
//C
this.state = 7;
RDebugUtils.currentLine=1572877;
 //BA.debugLineNum = 1572877;BA.debugLine="Try";
if (true) break;

case 7:
//try
this.state = 24;
this.catchState = 17;
this.state = 9;
if (true) break;

case 9:
//C
this.state = 10;
this.catchState = 17;
RDebugUtils.currentLine=1572879;
 //BA.debugLineNum = 1572879;BA.debugLine="Dim out As OutputStream";
_out = new anywheresoftware.b4a.objects.streams.File.OutputStreamWrapper();
RDebugUtils.currentLine=1572880;
 //BA.debugLineNum = 1572880;BA.debugLine="out = File.OpenOutput(SharedFolder,\"tmp.apk\",F";
_out = parent.__c.File.OpenOutput(__ref._sharedfolder /*String*/ ,"tmp.apk",parent.__c.False);
RDebugUtils.currentLine=1572881;
 //BA.debugLineNum = 1572881;BA.debugLine="File.Copy2(j.GetInputStream, out)";
parent.__c.File.Copy2((java.io.InputStream)(_j._getinputstream /*anywheresoftware.b4a.objects.streams.File.InputStreamWrapper*/ (null).getObject()),(java.io.OutputStream)(_out.getObject()));
RDebugUtils.currentLine=1572882;
 //BA.debugLineNum = 1572882;BA.debugLine="out.Close";
_out.Close();
RDebugUtils.currentLine=1572883;
 //BA.debugLineNum = 1572883;BA.debugLine="Log($\"Copy2 (saving) ok? TRUE\"$)";
parent.__c.LogImpl("91572883",("Copy2 (saving) ok? TRUE"),0);
RDebugUtils.currentLine=1572884;
 //BA.debugLineNum = 1572884;BA.debugLine="sStatusCode = OK_DOWNLOAD";
__ref._sstatuscode /*int*/  = __ref._ok_download /*int*/ ;
RDebugUtils.currentLine=1572885;
 //BA.debugLineNum = 1572885;BA.debugLine="If sVerbose Then Log($\"${TAB}new apk version d";
if (true) break;

case 10:
//if
this.state = 15;
if (__ref._sverbose /*boolean*/ ) { 
this.state = 12;
;}if (true) break;

case 12:
//C
this.state = 15;
parent.__c.LogImpl("91572885",(""+parent.__c.SmartStringFormatter("",(Object)(parent.__c.TAB))+"new apk version downloaded and ready to install"),0);
if (true) break;

case 15:
//C
this.state = 24;
;
 if (true) break;

case 17:
//C
this.state = 18;
this.catchState = 0;
RDebugUtils.currentLine=1572887;
 //BA.debugLineNum = 1572887;BA.debugLine="Log($\"Copy2 (saving) ok? FALSE\"$)";
parent.__c.LogImpl("91572887",("Copy2 (saving) ok? FALSE"),0);
RDebugUtils.currentLine=1572888;
 //BA.debugLineNum = 1572888;BA.debugLine="sStatusCode = ERR_DOWNLOAD";
__ref._sstatuscode /*int*/  = __ref._err_download /*int*/ ;
RDebugUtils.currentLine=1572889;
 //BA.debugLineNum = 1572889;BA.debugLine="If sVerbose Then Log($\"${TAB}failed download o";
if (true) break;

case 18:
//if
this.state = 23;
if (__ref._sverbose /*boolean*/ ) { 
this.state = 20;
;}if (true) break;

case 20:
//C
this.state = 23;
parent.__c.LogImpl("91572889",(""+parent.__c.SmartStringFormatter("",(Object)(parent.__c.TAB))+"failed download of new apk version"),0);
if (true) break;

case 23:
//C
this.state = 24;
;
RDebugUtils.currentLine=1572890;
 //BA.debugLineNum = 1572890;BA.debugLine="ToastMessageShow(LastException, True)";
parent.__c.ToastMessageShow(BA.ObjectToCharSequence(parent.__c.LastException(ba).getObject()),parent.__c.True);
 if (true) break;
if (true) break;

case 24:
//C
this.state = 33;
this.catchState = 0;
;
 if (true) break;

case 26:
//C
this.state = 27;
RDebugUtils.currentLine=1572893;
 //BA.debugLineNum = 1572893;BA.debugLine="Log($\"${TAB}Error: ${J.ErrorMessage}\"$)";
parent.__c.LogImpl("91572893",(""+parent.__c.SmartStringFormatter("",(Object)(parent.__c.TAB))+"Error: "+parent.__c.SmartStringFormatter("",(Object)(_j._errormessage /*String*/ ))+""),0);
RDebugUtils.currentLine=1572894;
 //BA.debugLineNum = 1572894;BA.debugLine="sStatusCode = ERR_HTTP";
__ref._sstatuscode /*int*/  = __ref._err_http /*int*/ ;
RDebugUtils.currentLine=1572895;
 //BA.debugLineNum = 1572895;BA.debugLine="If sVerbose Then Log($\"${TAB}error in httputils";
if (true) break;

case 27:
//if
this.state = 32;
if (__ref._sverbose /*boolean*/ ) { 
this.state = 29;
;}if (true) break;

case 29:
//C
this.state = 32;
parent.__c.LogImpl("91572895",(""+parent.__c.SmartStringFormatter("",(Object)(parent.__c.TAB))+"error in httputils2"),0);
if (true) break;

case 32:
//C
this.state = 33;
;
RDebugUtils.currentLine=1572896;
 //BA.debugLineNum = 1572896;BA.debugLine="ToastMessageShow($\"Error: ${J.ErrorMessage}\"$,";
parent.__c.ToastMessageShow(BA.ObjectToCharSequence(("Error: "+parent.__c.SmartStringFormatter("",(Object)(_j._errormessage /*String*/ ))+"")),parent.__c.True);
 if (true) break;

case 33:
//C
this.state = 34;
;
RDebugUtils.currentLine=1572898;
 //BA.debugLineNum = 1572898;BA.debugLine="j.Release";
_j._release /*String*/ (null);
RDebugUtils.currentLine=1572899;
 //BA.debugLineNum = 1572899;BA.debugLine="If sStatusCode == OK_DOWNLOAD Then";
if (true) break;

case 34:
//if
this.state = 43;
if (__ref._sstatuscode /*int*/ ==__ref._ok_download /*int*/ ) { 
this.state = 36;
}if (true) break;

case 36:
//C
this.state = 37;
RDebugUtils.currentLine=1572900;
 //BA.debugLineNum = 1572900;BA.debugLine="SendInstallIntent";
__ref._sendinstallintent /*String*/ (null);
RDebugUtils.currentLine=1572901;
 //BA.debugLineNum = 1572901;BA.debugLine="sStatusCode = OK_INSTALL";
__ref._sstatuscode /*int*/  = __ref._ok_install /*int*/ ;
RDebugUtils.currentLine=1572902;
 //BA.debugLineNum = 1572902;BA.debugLine="If sVerbose Then Log($\"${TAB}user asked to inst";
if (true) break;

case 37:
//if
this.state = 42;
if (__ref._sverbose /*boolean*/ ) { 
this.state = 39;
;}if (true) break;

case 39:
//C
this.state = 42;
parent.__c.LogImpl("91572902",(""+parent.__c.SmartStringFormatter("",(Object)(parent.__c.TAB))+"user asked to install new apk"),0);
if (true) break;

case 42:
//C
this.state = 43;
;
 if (true) break;

case 43:
//C
this.state = 44;
;
 if (true) break;

case 44:
//C
this.state = -1;
;
RDebugUtils.currentLine=1572905;
 //BA.debugLineNum = 1572905;BA.debugLine="Finito";
__ref._finito /*String*/ (null);
RDebugUtils.currentLine=1572906;
 //BA.debugLineNum = 1572906;BA.debugLine="End Sub";
if (true) break;
}} 
       catch (Exception e0) {
			
if (catchState == 0)
    throw e0;
else {
    state = catchState;
ba.setLastException(e0);}
            }
        }
    }
}
public void  _updateapk(reparto_intmex.keymon.lat.cl_appupdate __ref,boolean _pstatus) throws Exception{
RDebugUtils.currentModule="cl_appupdate";
if (Debug.shouldDelegate(ba, "updateapk", true))
	 {Debug.delegate(ba, "updateapk", new Object[] {_pstatus}); return;}
ResumableSub_UpdateApk rsub = new ResumableSub_UpdateApk(this,__ref,_pstatus);
rsub.resume(ba, null);
}
public static class ResumableSub_UpdateApk extends BA.ResumableSub {
public ResumableSub_UpdateApk(reparto_intmex.keymon.lat.cl_appupdate parent,reparto_intmex.keymon.lat.cl_appupdate __ref,boolean _pstatus) {
this.parent = parent;
this.__ref = __ref;
this._pstatus = _pstatus;
this.__ref = parent;
}
reparto_intmex.keymon.lat.cl_appupdate __ref;
reparto_intmex.keymon.lat.cl_appupdate parent;
boolean _pstatus;
boolean _okwebver = false;
long _fsize = 0L;

@Override
public void resume(BA ba, Object[] result) throws Exception{
RDebugUtils.currentModule="cl_appupdate";

    while (true) {
        switch (state) {
            case -1:
return;

case 0:
//C
this.state = 1;
RDebugUtils.currentLine=1507329;
 //BA.debugLineNum = 1507329;BA.debugLine="LogColor(\"---- AppUpdating.UpdateApk\", LogColor1)";
parent.__c.LogImpl("91507329","---- AppUpdating.UpdateApk",__ref._logcolor1 /*int*/ );
RDebugUtils.currentLine=1507330;
 //BA.debugLineNum = 1507330;BA.debugLine="If Not(pstatus) Then";
if (true) break;

case 1:
//if
this.state = 61;
if (parent.__c.Not(_pstatus)) { 
this.state = 3;
}else {
this.state = 11;
}if (true) break;

case 3:
//C
this.state = 4;
RDebugUtils.currentLine=1507331;
 //BA.debugLineNum = 1507331;BA.debugLine="sStatusCode = ERR_NOPERM";
__ref._sstatuscode /*int*/  = __ref._err_noperm /*int*/ ;
RDebugUtils.currentLine=1507332;
 //BA.debugLineNum = 1507332;BA.debugLine="If sVerbose Then Log(TAB & \"no permissions from";
if (true) break;

case 4:
//if
this.state = 9;
if (__ref._sverbose /*boolean*/ ) { 
this.state = 6;
;}if (true) break;

case 6:
//C
this.state = 9;
parent.__c.LogImpl("91507332",parent.__c.TAB+"no permissions from user to install new apk",0);
if (true) break;

case 9:
//C
this.state = 61;
;
 if (true) break;

case 11:
//C
this.state = 12;
RDebugUtils.currentLine=1507334;
 //BA.debugLineNum = 1507334;BA.debugLine="Wait For(IsvalidWV) Complete (OkWebVer As Boolea";
parent.__c.WaitFor("complete", ba, new anywheresoftware.b4a.shell.DebugResumableSub.DelegatableResumableSub(this, "cl_appupdate", "updateapk"), __ref._isvalidwv /*anywheresoftware.b4a.keywords.Common.ResumableSubWrapper*/ (null));
this.state = 62;
return;
case 62:
//C
this.state = 12;
_okwebver = (Boolean) result[1];
;
RDebugUtils.currentLine=1507335;
 //BA.debugLineNum = 1507335;BA.debugLine="If (IsValidCV And OkWebVer) Then							'here we";
if (true) break;

case 12:
//if
this.state = 60;
if ((__ref._isvalidcv /*boolean*/ (null) && _okwebver)) { 
this.state = 14;
}if (true) break;

case 14:
//C
this.state = 15;
RDebugUtils.currentLine=1507336;
 //BA.debugLineNum = 1507336;BA.debugLine="If curver < webver Then";
if (true) break;

case 15:
//if
this.state = 59;
if ((double)(Double.parseDouble(__ref._curver /*String*/ ))<(double)(Double.parseDouble(__ref._webver /*String*/ ))) { 
this.state = 17;
}else {
this.state = 52;
}if (true) break;

case 17:
//C
this.state = 18;
RDebugUtils.currentLine=1507338;
 //BA.debugLineNum = 1507338;BA.debugLine="If IsNumber(webfsize) Then";
if (true) break;

case 18:
//if
this.state = 31;
if (parent.__c.IsNumber(__ref._webfsize /*String*/ )) { 
this.state = 20;
}if (true) break;

case 20:
//C
this.state = 21;
RDebugUtils.currentLine=1507339;
 //BA.debugLineNum = 1507339;BA.debugLine="Dim fsize As Long = webfsize";
_fsize = (long)(Double.parseDouble(__ref._webfsize /*String*/ ));
RDebugUtils.currentLine=1507340;
 //BA.debugLineNum = 1507340;BA.debugLine="If fsize*2 > GetFreeSpace Then";
if (true) break;

case 21:
//if
this.state = 30;
if (_fsize*2>__ref._getfreespace /*long*/ (null)) { 
this.state = 23;
}if (true) break;

case 23:
//C
this.state = 24;
RDebugUtils.currentLine=1507341;
 //BA.debugLineNum = 1507341;BA.debugLine="sStatusCode = ERR_NOSPACE";
__ref._sstatuscode /*int*/  = __ref._err_nospace /*int*/ ;
RDebugUtils.currentLine=1507342;
 //BA.debugLineNum = 1507342;BA.debugLine="If sVerbose Then Log($\"${TAB}no enough avail";
if (true) break;

case 24:
//if
this.state = 29;
if (__ref._sverbose /*boolean*/ ) { 
this.state = 26;
;}if (true) break;

case 26:
//C
this.state = 29;
parent.__c.LogImpl("91507342",(""+parent.__c.SmartStringFormatter("",(Object)(parent.__c.TAB))+"no enough available space to download apk"),0);
if (true) break;

case 29:
//C
this.state = 30;
;
 if (true) break;

case 30:
//C
this.state = 31;
;
 if (true) break;
;
RDebugUtils.currentLine=1507345;
 //BA.debugLineNum = 1507345;BA.debugLine="If sStatusCode >= 0 Then";

case 31:
//if
this.state = 50;
if (__ref._sstatuscode /*int*/ >=0) { 
this.state = 33;
}if (true) break;

case 33:
//C
this.state = 34;
RDebugUtils.currentLine=1507346;
 //BA.debugLineNum = 1507346;BA.debugLine="sStatusCode = OK_NEWERAPK			'info file tells";
__ref._sstatuscode /*int*/  = __ref._ok_newerapk /*int*/ ;
RDebugUtils.currentLine=1507347;
 //BA.debugLineNum = 1507347;BA.debugLine="If sVerbose Then Log($\"${TAB}Newer version av";
if (true) break;

case 34:
//if
this.state = 39;
if (__ref._sverbose /*boolean*/ ) { 
this.state = 36;
;}if (true) break;

case 36:
//C
this.state = 39;
parent.__c.LogImpl("91507347",(""+parent.__c.SmartStringFormatter("",(Object)(parent.__c.TAB))+"Newer version available. Now I try its downloading"),0);
if (true) break;

case 39:
//C
this.state = 40;
;
RDebugUtils.currentLine=1507348;
 //BA.debugLineNum = 1507348;BA.debugLine="If sNewVerApk = \"\" Then";
if (true) break;

case 40:
//if
this.state = 49;
if ((__ref._snewverapk /*String*/ ).equals("")) { 
this.state = 42;
}if (true) break;

case 42:
//C
this.state = 43;
RDebugUtils.currentLine=1507349;
 //BA.debugLineNum = 1507349;BA.debugLine="sStatusCode = ERR_NOAPK";
__ref._sstatuscode /*int*/  = __ref._err_noapk /*int*/ ;
RDebugUtils.currentLine=1507350;
 //BA.debugLineNum = 1507350;BA.debugLine="If sVerbose Then Log($\"${TAB}missing apk fil";
if (true) break;

case 43:
//if
this.state = 48;
if (__ref._sverbose /*boolean*/ ) { 
this.state = 45;
;}if (true) break;

case 45:
//C
this.state = 48;
parent.__c.LogImpl("91507350",(""+parent.__c.SmartStringFormatter("",(Object)(parent.__c.TAB))+"missing apk file full path indication"),0);
if (true) break;

case 48:
//C
this.state = 49;
;
 if (true) break;

case 49:
//C
this.state = 50;
;
 if (true) break;

case 50:
//C
this.state = 59;
;
 if (true) break;

case 52:
//C
this.state = 53;
RDebugUtils.currentLine=1507354;
 //BA.debugLineNum = 1507354;BA.debugLine="sStatusCode = NO_NEWERAPK";
__ref._sstatuscode /*int*/  = __ref._no_newerapk /*int*/ ;
RDebugUtils.currentLine=1507355;
 //BA.debugLineNum = 1507355;BA.debugLine="If sVerbose Then Log($\"${TAB}No newer version";
if (true) break;

case 53:
//if
this.state = 58;
if (__ref._sverbose /*boolean*/ ) { 
this.state = 55;
;}if (true) break;

case 55:
//C
this.state = 58;
parent.__c.LogImpl("91507355",(""+parent.__c.SmartStringFormatter("",(Object)(parent.__c.TAB))+"No newer version available on webserver."),0);
if (true) break;

case 58:
//C
this.state = 59;
;
 if (true) break;

case 59:
//C
this.state = 60;
;
 if (true) break;

case 60:
//C
this.state = 61;
;
 if (true) break;

case 61:
//C
this.state = -1;
;
RDebugUtils.currentLine=1507359;
 //BA.debugLineNum = 1507359;BA.debugLine="TryApkUpdate						'if available and permitted, do";
__ref._tryapkupdate /*void*/ (null);
RDebugUtils.currentLine=1507360;
 //BA.debugLineNum = 1507360;BA.debugLine="End Sub";
if (true) break;

            }
        }
    }
}
}